EDMENU:
     call CLS

     call MUTE

     ld hl, GFX_EDMENU
     call DEPACK_SCR

     call ED_MENUTXT

     call ED_DRAWTIRA

     call WAITFORNOKEY

     EDMENU_Ciclo:

     call JOYSTICK_TRIGGER

     ld a, (JOYSTICK)
     bit 0, a
     call nz, ED_DER

     ld a, (JOYSTICK)
     bit 1, a
     call nz, ED_IZQ

     call KFIND

     cp KEY_1
     jp z, ED_CHANGESET
     cp KEY_2
     jp z, ED_LOAD

     cp KEY_3
     jp z, ED_SAVE
     cp KEY_4
     jp z, ED_ERASESET

     cp KEY_5
     jp z, ED_NUEVONIVEL
     cp KEY_6
     jp z, ED_EDITOR
     cp KEY_7
     jp z, ED_MOVELEVEL
     cp KEY_8
     jp z, ED_DELETELEVEL

     cp KEY_0
     jp nz, EDMENU_Ciclo

     call UNPACK_MENU
     jp MENU

ED_MENUCLS:
     call ED_MENUcls
     call ED_SHOWDATA
     ret

ED_MENUcls:
     ld de, $ff00
     ld (ATTR_ACT), de

     ld hl, STR_LINEAENBLANCO
     ld bc, $1600
     call PRINTSTR

     ld bc, $0904

ED_MENUCLS_Bucle:
     ld hl, STR_LINEAENBLANCO + 8
     call PRINTSTR
     ld c, 04
     inc b
     ld a, b
     cp $15
     ret z

     jp ED_MENUCLS_Bucle


ED_MENUTXT:

     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_MENU4 + 3
     ld bc, #090a
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR1
     ld bc, #0c08
     call PRINTSTR

     inc hl
     ld bc, #0d08
     call PRINTSTR

     inc hl
     ld bc, #0e08
     call PRINTSTR

     inc hl
     ld bc, #0f08
     call PRINTSTR

     inc hl
     ld bc, #1108
     call PRINTSTR

     inc hl
     ld bc, #1208
     call PRINTSTR

     inc hl
     ld bc, #1308
     call PRINTSTR

     inc hl
     ld bc, #1408
     call PRINTSTR

     inc hl
     ld bc, #1605
     call PRINTSTR
     
     ED_MENUTXT_SetType:

     ld hl, SETTYPE
     ld a, (hl)

     ld hl, STR_SETTYPE0
     cp 1
     jr z, EDMENU_0

     ld hl, STR_SETTYPE1

     EDMENU_0:

     ld e, PAPER_BLACK | INK_WHITE
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #0c10
     call PRINTSTR

     ret

ED_ACTIVABANK:
     di
     ld b, 6          ; Activamos el banco de los niveles
     jp SETRAMBANK

ED_DESACTIVABANK:
     ld b, 0          ; Activamos el banco 0
     call SETRAMBANK
     ei                        
     ret

ED_IZQ:
     ld hl, ED_LEVACT
     ld a, (hl)
     and a
     ret z

     dec (hl)
     call ED_DRAWTIRA
     ret

ED_DER:
     ld hl, ED_LEVACT
     ld a, (hl)
     ld b, a
     ld a, (ED_NUMLEV)
     dec a
     cp b
     ret z

     inc (hl)
     call ED_DRAWTIRA
     ret


ED_LOAD:
     ld a, (ED_NUMLEV)
     and a
     call nz, ED_LOAD_CONFIRM

     jp c, EDMENU_Ciclo


     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR2 + 2
     ld bc, #090b
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_STARTTAPE
     ld bc, #0e0b
     call PRINTSTR

     inc hl
     ld bc, #0f07
     call PRINTSTR

     call WAITFORKEY

    call ED_ACTIVABANK

    push iy
    ld iy, $5C3A ;            IY holds +ERR-NR always.

    ld ix, $c000
    ld de, $4000
    ld a, #bb
    scf

    inc d
    ex af, af'
    dec d

    ld hl, #0555
    push hl

    in a, (#fe)
    rra
    and #20
    or #02
    ld c, a
    cp a

    call #056B
    
    pop iy

    push af
    xor a
    out (#fe), a
    pop af
   
    jp nc, LOAD_ERROR     ; VERIFICAR CARGA CORRECTA
    
    ld d, $ff
    ld hl, $c000

    EDLOAD_BucleCont:

    inc d

    ld a, (hl)
    inc hl
    ld b, (hl)
    inc hl

    or b
    jp nz, EDLOAD_BucleCont

    ld a, d

    ld (ED_NUMLEV), a


    ld a, 0
    out (#fe), a
    call ED_MENUTXT

    call ED_DESACTIVABANK

    jp ED_DELLEV_Exit2    ; AJUSTAR PUNTERO ED_PUNTEROSIGLEV


    LOAD_ERROR:
    call ED_DESACTIVABANK

    call ED_MENUCLS
    
    xor a
    out (#fe), a
    
    ld e, PAPER_BLACK | INK_GREEN | BRIGHT
    ld d, #ff
    ld (ATTR_ACT), de

    ld hl, STR_LOADERROR
    ld bc, #0c0a
    call PRINTSTR
     
    inc hl
    ld bc, #0e09
    call PRINTSTR
       
    call WAITFORKEY
       
    call ED_MENUTXT
    jp EDMENU_Ciclo
       
    
ED_LOAD_CONFIRM:
     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR2 + 2
     ld bc, #090b
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_CONFIRM
     ld bc, #0c06
     call PRINTSTR

     inc hl
     ld bc, #0d0a
     call PRINTSTR

     ld e, PAPER_BLACK | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_CONFIRMYN
     ld bc, #0f07
     call PRINTSTR

     call CONFIRM

     ccf

     ret nc

     call ED_MENUTXT
     scf
     ret

ED_SAVE:
     ld a, (ED_NUMLEV)
     and a
     jp z, EDMENU_Ciclo

     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR3 + 2
     ld bc, #090b
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_STARTTAPE
     ld bc, #0e0b
     call PRINTSTR

     inc hl
     ld bc, #0f07
     call PRINTSTR

     call WAITFORKEY

    call ED_ACTIVABANK

    ld ix, $c000
    ld de, $4000
    ld a, #bb
    ld hl, SAVE_Hook
    push hl

    ld hl, 1612

    call #04d0

    SAVE_Hook:

    call ED_DESACTIVABANK

    ld a, 0
    out (#fe), a
    call ED_MENUTXT

     jp EDMENU_Ciclo


ED_CHANGESET:
     ld a, (ED_NUMLEV)
     and a
     jp z, EDMENU_Ciclo

     ld hl, SETTYPE
     ld a, (hl)

     cpl
     and 7
     ld (hl),a

     xor a
     ld (LEVELACT), a
     ld (MAXLEVEL), a

     call ED_MENUTXT_SetType

     call WAITFORNOKEY
     jp EDMENU_Ciclo

ED_DRAWTIRA:
     ld hl, 22528
     ld a, PAPER_BLACK | INK_BLACK
     ld bc, 223
     call SETMEM

     ld a, (ED_NUMLEV)
     and a
     ret z

     call ED_ACTIVABANK

     ld a, (ED_LEVACT)
     and a
     jp z, ED_DRAWTIRA_NoPrev

     dec a

     call DUMPLEVEL

     ld a, (LEVEL_DATA)
     ld hl, SUBNIVELES
     ld (hl), a
     inc hl
     ld (hl), a

     ld e, PAPER_YELLOW | INK_BLACK
     ld bc, $0003
     call DIBUJAPEQUE

     ld e, INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, $0603
     ld hl, STR_PREV
     call PRINTSTR

     ED_DRAWTIRA_NoPrev:

     ld a, (ED_LEVACT)

     call DUMPLEVEL

     ld a, (LEVEL_DATA)
     ld hl, SUBNIVELES
     ld (hl), a
     inc hl
     ld (hl), a

     ld e, PAPER_WHITE | INK_BLUE
     ld bc, $000d
     call DIBUJAPEQUE


     ld a, (ED_LEVACT)
     inc a

     ld hl, ED_NUMLEV
     cp (hl)
     jp z, ED_DRAWTIRA_Exit


     call DUMPLEVEL

     ld a, (LEVEL_DATA)
     ld hl, SUBNIVELES
     ld (hl), a
     inc hl
     ld (hl), a



     ld e, PAPER_YELLOW | INK_BLACK
     ld bc, $0017
     call DIBUJAPEQUE

     ld e, INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, $0617
     ld hl, STR_NEXT
     call PRINTSTR

     ED_DRAWTIRA_Exit:

     call ED_DESACTIVABANK
     ret

ED_SHOWDATA:
     ld e, INK_CYAN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, $1000
     ld hl, STR_FREEMEM
     call PRINTSTR

     ld bc, $1100
     inc hl
     call PRINTSTR

     ld bc, $1200
     ld hl, STR_LINEAENBLANCO + 26
     call PRINTSTR

     ld bc, $101a
     ld hl, STR_TOTALLEV
     call PRINTSTR

     ld bc, $111a
     inc hl
     call PRINTSTR

     ld bc, $121a
     ld hl, STR_LINEAENBLANCO + 26
     call PRINTSTR

     ld e, INK_WHITE
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, $ffff
     ld de, (ED_PUNTEROSIGLEV)
     and a
     sbc hl, de
     ex de, hl

     ld bc, $1205
     call PRINTNUM

     ld a, (ED_NUMLEV)
     ld e, a
     ld d, 0
     ld bc, $121d
     call PRINTNUM

     ret



ED_ERASESET:
     ld a, (ED_NUMLEV)
     and a
     jp z, EDMENU_Ciclo

     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR4 + 2
     ld bc, #090a
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_CONFIRM
     ld bc, #0c06
     call PRINTSTR

     inc hl
     ld bc, #0d0a
     call PRINTSTR

     ld e, PAPER_BLACK | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_CONFIRMYN
     ld bc, #0f07
     call PRINTSTR

     call CONFIRM

     call c, ED_RESET
     call ED_MENUTXT
     call ED_SHOWDATA

     call WAITFORNOKEY
     jp EDMENU_Ciclo


CONFIRM:

     call KFIND
     cp KEY_Y
     scf
     ret z

     and a
     cp KEY_N
     ret z

     jp CONFIRM



ED_NUEVONIVEL:
     call ED_MENUCLS

     ld hl, ED_NUMLEV
     ld a, (hl)
     cp #64          ; Has llegado a definir 100 niveles?
     jp z,ED_LIMIT_ERROR

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR5 + 2
     ld bc, #0909
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_NUMBSL
     ld bc, #0e06
     call PRINTSTR

     ld e, PAPER_BLACK | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     inc hl
     ld bc, #0f0a
     call PRINTSTR

     call ED_ACTIVABANK


     ED_NEWLEVEL_WAITFORSL:

     call KFIND

     cp KEY_1
     jp z, ED_NEWLEVEL_1SL
     cp KEY_4
     jp z, ED_NEWLEVEL_4SL
     cp KEY_9
     jp z, ED_NEWLEVEL_9SL

     jp ED_NEWLEVEL_WAITFORSL

     ED_NEWLEVEL_AFTERASK:

     call ED_NEWLEVEL_CheckMem

     jp c, ED_NEWLEVEL_Exit
     
     push af

     ld hl, ED_NUMLEV
     ld a, (hl)
     inc (hl)        ; Suma uno: Un nivel nuevo hecho


     ld (ED_LEVACT), a

     ld hl, $c000    ; Vamos a escribir el puntero al nuevo nivel en la tabla de punteros
     sla a            ; Cada puntero ocupa dos bytes. Vamos a el nmero de nivel que tenemos multiplicado por dos...
     ld d, 0
     ld e, a
     add hl, de
     ld de, (ED_PUNTEROSIGLEV)      ; Ahora cargamos en DE el puntero al nuevo nivel
     ld (hl), e                     ; Y lo grabamos en la tabla
     inc hl
     ld (hl), d

     pop af


     ld e, 32  ; 32 bytes por cada subnivel
     ld d, 0

     ld hl, 0
     ld b, a

     ED_NEWLEVEL_ADDBYTES:

     add hl, de

     djnz ED_NEWLEVEL_ADDBYTES      ; Tantas veces 32 bytes como valga A

     dec hl
     ld b, h
     ld c, l                        ; Y ahora lo pasamos a BC para el LDIR



     ld hl, (ED_PUNTEROSIGLEV)
     ld (hl), a
     inc hl                        ; Vaca el nivel que vamos a crear
     ld (hl), $02                     ; Lo vamos a llenar de 1's           *********************************************************************************************************************************************************

;     ld bc, 287

     ld d, h
     ld e, l
     inc de
     ldir

     inc hl
     ld (ED_PUNTEROSIGLEV), hl      ; Y ajustamos el puntero al siguiente nivel

     ED_NEWLEVEL_Exit:

     call ED_DESACTIVABANK

     call ED_DRAWTIRA

     call ED_MENUTXT
     call WAITFORNOKEY
     jp EDMENU_Ciclo


ED_NEWLEVEL_1SL:
     ld a, 1
     jp ED_NEWLEVEL_AFTERASK

ED_NEWLEVEL_4SL:
     ld a, 4
     jp ED_NEWLEVEL_AFTERASK

ED_NEWLEVEL_9SL:
     ld a, 9
     jp ED_NEWLEVEL_AFTERASK

ED_NEWLEVEL_CheckMem:

     ld hl, (ED_PUNTEROSIGLEV)

     push af

     ld d, 0

     sla a
     rl d
     sla a
     rl d
     sla a
     rl d
     sla a
     rl d
     sla a
     rl d
     ld e, a                          ; DE = A *32

     inc de

     pop af

     add hl, de

     ret nc

     call ED_DESACTIVABANK

     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_RED
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_ERROR
     ld bc, #090c
     call PRINTSTRX2

     ld e, PAPER_BLACK | WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_NOMEMORY
     ld bc, #0e04
     call PRINTSTR

     call WAITFORKEY

     scf
     ret

ED_LIMIT_ERROR:
     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_RED
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_ERROR
     ld bc, #090c
     call PRINTSTRX2

     ld e, PAPER_BLACK | WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_LIMITREACHED
     ld bc, #0e04
     call PRINTSTR

     call WAITFORKEY

     jp ED_NEWLEVEL_Exit


ED_RESET:

       call ED_ACTIVABANK
       ld hl, $c000
       ld de, $c001
       ld bc, 16383
       ld (hl),l
       ldir
       call ED_DESACTIVABANK

       ld hl, SETTYPE
       ld (hl), 1

       ld hl, ED_NUMLEV
       ld (hl), 0

       ld bc, $c0ca
       ld (ED_PUNTEROSIGLEV), bc

       ld hl, ED_LEVACT
       ld (hl), 0

       ld a, KEY_N
       call ED_DRAWTIRA

       ret

ED_DELETELEVEL:
     ld a, (ED_NUMLEV)
     and a
     jp z, EDMENU_Ciclo

     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR8 + 2
     ld bc, #0909
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_CONFIRMYN
     ld bc, #0c07
     call PRINTSTR

     call CONFIRM

     push af

     call ED_MENUTXT

     pop af

     jp nc, EDMENU_Ciclo

     call ED_ACTIVABANK

     ld a, (ED_LEVACT)
     ld hl, ED_NUMLEV
     ld b, (hl)
     dec b
     cp b
     jp z, ED_DELLEV_Exit

     ld hl, $c000
     ld a, (ED_LEVACT)
     ld e, a
     ld d, l
     add hl, de
     add hl, de                       ; Tengo HL apuntando al puntero del nivel a borrar (actual)

     ld e, (hl)
     inc hl
     ld d, (hl)                       ; Ahora tengo en DE el puntero al nivel a borrar (actual)
     dec hl

     push de                          ; Puntero del nivel a borrar

     ld d, h
     ld e, l
     inc hl
     inc hl                           ; DE apunta al puntero del nivel actual, y HL al puntero del siguiente

     ld c, (hl)
     inc hl
     ld b, (hl)
     dec hl

     ED_DELLEV_PunteroBucle:

     ld a, (hl)

     and a
     jp z, ED_DELLEV_Datos

     ldi
     ldi

     jp ED_DELLEV_PunteroBucle


     ED_DELLEV_Datos:

     pop de                           ; En DE est el puntero del nivel a borrar
     push de

     ld hl, $ffff
     sbc hl, de
     ld b, h
     ld c, l

     ld a, (de)

     ld h, 0

     sla a
     rl h
     sla a
     rl h
     sla a
     rl h
     sla a
     rl h
     sla a
     rl h
     ld l, a                          ; HL = A *32

     inc hl

     ld (VAR3), hl                    ; Metemos en aqu el nmero de bytes que tenemos que restar a los punteros para ajustarlos

     add hl, de

     ldir

     ld hl, $bfff

     pop de                             ; Ponemos en DE el puntero al donde empezaba el nivel borrado

     ED_DELLEV_AjustaPunterosBucle

     inc hl
     ld c, (hl)
     inc hl
     ld b, (hl)

     xor a
     or b
     jp z, ED_DELLEV_Exit

     call CP16                       ; Comparamos cada puntero de la lista con donde empezaba el nivel borrado

     call nc, ED_DELLEV_AjustaPunteros_Resta

     jp ED_DELLEV_AjustaPunterosBucle

     ED_DELLEV_AjustaPunteros_Resta:

     push de
     push hl

     ld l, c
     ld h, b                         ; Ahora tengo en HL el puntero del nivel que hay que ajustar

     ld de, (VAR3)                   ; En DE tengo los bytes que hay que restar

     and a
     sbc hl, de                      ; En HL tengo el puntero "ajustado"

     ex de, hl

     pop hl

     ld (hl), d
     dec hl
     ld (hl), e

     inc hl
     pop de

     ret

     ED_DELLEV_Exit:

     ld hl, ED_NUMLEV
     dec (hl)
     ld a, (hl)
     and a
     jp nz, ED_DELLEV_Exit2

     call ED_RESET
     call ED_MENUTXT_SetType
     call ED_SHOWDATA
     jp EDMENU_Ciclo

     ED_DELLEV_Exit2:                ; Ahora solo falta ajustar el puntero al pximo nivel

     ld bc, 0

     ld hl, $c000
     ld a, (ED_NUMLEV)
     dec a
     ld e, a
     ld d, l
     add hl, de
     add hl, de                       ; Tengo HL apuntando al puntero del ltimo nivel

     xor a                            ; Vamos a aadir los dos 0 de "fin de juego"
     inc hl
     inc hl
     ld (hl),a
     inc hl
     ld (hl), a

     ld hl, $c000

     ED_DELLEV_Exit2_Bucle:

     ld e, (hl)
     inc hl
     ld d, (hl)
     inc hl

     xor a
     or d
     jp z, ED_DELLEV_Exit2_SalBucle

     call CP16

     jp nc, ED_DELLEV_Exit2_Bucle

     ld b, d
     ld c, e

     jp ED_DELLEV_Exit2_Bucle

     ED_DELLEV_Exit2_SalBucle:

     push bc
     pop de

     ld a, (de)                       ; A nmero de subniveles

     inc de

     ld h, 0

     sla a
     rl h
     sla a
     rl h
     sla a
     rl h
     sla a
     rl h
     sla a
     rl h
     ld l, a                          ; HL = A *32

     add hl, de                       ; Ahora tengo en hl el puntero al ltimo dato vlido + 1

     ld (ED_PUNTEROSIGLEV), hl

     ld hl, ED_LEVACT
     ld a, (ED_NUMLEV)
     dec a
     ld (hl), a

     call ED_DRAWTIRA
     call ED_SHOWDATA

     call WAITFORNOKEY
     jp EDMENU_Ciclo


ED_MOVELEVEL:

     ld a, (ED_NUMLEV)
     cp 2
     jp c, EDMENU_Ciclo

     call ED_MENUCLS

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_EDITOR7 + 2
     ld bc, #090a
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_MOVELEVEL
     ld bc, #0e06
     call PRINTSTR

     inc hl
     ld bc, #0f07
     call PRINTSTR

     ld e, PAPER_BLACK | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     inc hl
     ld bc, #100a
     call PRINTSTR

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     inc hl
     ld bc, #110a
     call PRINTSTR


     ED_MOVELEVEL_Ciclo:

     call JOYSTICK_TRIGGER

     ld a, (JOYSTICK)
     bit 0, a
     jp nz, ED_MOVE_RIGHT

     ld a, (JOYSTICK)
     bit 1, a
     jp nz, ED_MOVE_LEFT

     ld a, (JOYSTICK)
     bit 4, a
     jp nz, ED_MOVELEVEL_EXIT

     jp ED_MOVELEVEL_Ciclo

     ED_MOVELEVEL_EXIT:

     call ED_MENUTXT
     call WAITFORNOKEY
     jp EDMENU_Ciclo


ED_MOVE_LEFT:
     ld a, (ED_LEVACT)
     and a
     jp z, ED_MOVELEVEL_Ciclo

     call ED_ACTIVABANK

     ld a, (ED_LEVACT)

     ld hl, $c000
     sla a
     ld d, l
     ld e, a
     add hl, de           ; En HL tenemos el puntero al nivel actual

     push hl
     pop ix               ; Y ahora lo tenemos en IX

     ld b, (ix + 1)
     ld c, (ix + 0)
     ld d, (ix - 1)
     ld e, (ix - 2)

     ld (ix + 1), d
     ld (ix + 0), e
     ld (ix - 1), b
     ld (ix - 2), c

     call ED_DESACTIVABANK

     call ED_IZQ
     jp ED_MOVELEVEL_Ciclo


ED_MOVE_RIGHT:
     ld a, (ED_LEVACT)
     inc a
     ld hl, ED_NUMLEV
     cp (hl)

     jp z, ED_MOVELEVEL_Ciclo

     call ED_ACTIVABANK

     ld a, (ED_LEVACT)

     ld hl, $c000
     sla a
     ld d, l
     ld e, a
     add hl, de           ; En HL tenemos el puntero al nivel actual

     push hl
     pop ix               ; Y ahora lo tenemos en IX

     ld b, (ix + 1)
     ld c, (ix + 0)
     ld d, (ix + 3)
     ld e, (ix + 2)

     ld (ix + 1), d
     ld (ix + 0), e
     ld (ix + 3), b
     ld (ix + 2), c

     call ED_DESACTIVABANK

     call ED_DER
     jp ED_MOVELEVEL_Ciclo


EDITOR_SHOWSL:
     ld bc, #0010
     ld e, PAPER_YELLOW | INK_BLACK
     call DIBUJAPEQUE

     call CUENTABLANCOS

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld a, (ED_SLACT)
     ld d, 0
     ld e, a
     ld bc, #040c
     call PRINTNUM

     ld a, (LEVEL_DATA)
     cp 1
     ret z

     cp 9
     jp z, ED_RESALTAPEQUE9

     ld hl, ED_RESALTASL4
     jp ED_RESALTASL

     ED_RESALTAPEQUE9:
     ld hl, ED_RESALTASL9

     ED_RESALTASL:

     ld a, (ED_SLACT)

     ld e, a
     ld d, 0
     add hl, de
     add hl, de

     ld c, (hl)
     inc hl
     ld b, (hl)

     ld de, 31

     call ATT_LOCATE
     ld (hl), PAPER_WHITE | INK_BLUE
     inc hl
     ld (hl), PAPER_WHITE | INK_BLUE
     add hl, de
     ld (hl), PAPER_WHITE | INK_BLUE
     inc hl
     ld (hl), PAPER_WHITE | INK_BLUE

     ret


ED_SHOWWARNING:
     ld e, PAPER_RED | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_ED_WARNING
     ld bc,#1514
     call PRINTSTR

     ld e, PAPER_BLACK | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     inc hl
     ld bc,#1614
     call PRINTSTR

     inc hl
     ld bc,#1713
     call PRINTSTR

     jp CICLOEDITOR


ED_MOVESL:

     call RETMODOCURSOR
     and a
     jp nz, CICLOEDITOR

     call CUENTABLANCOS
     ld a, (BLANCOSNIVEL)
     and a
     jp z, CICLOEDITOR

     ld a, (LEVEL_DATA)
     cp 1
     jp z, CICLOEDITOR

     ld a, (LEVEL_DATA)
     cp 9
     jp z, ED_MOVESL_9

     ; 4 ARRIBA

     ld a, (JOYSTICK)
     bit 3, a
     jp z, EDMOVESL_4_1

     ld a, (ED_SLACT)
     bit 1, a
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     sub 2
     ld (ED_SLACT), a

     ld hl, (DIBUJOACTUAL)
     ld de, 64
     sbc hl, de
     ld (DIBUJOACTUAL), hl

     ld a, #0f
     ld (COORDENADAS + 1), a

     jp ED_MOVESL_EXIT


     EDMOVESL_4_1:        ; 4 ABAJO

     ld a, (JOYSTICK)
     bit 2, a
     jp z, EDMOVESL_4_2

     ld a, (ED_SLACT)
     bit 1, a
     jp nz, CICLOEDITOR ; jp nz, ED_MOVESL_EXIT
     add a, 2
     ld (ED_SLACT), a

     ld hl, (DIBUJOACTUAL)
     ld de, 64
     add hl, de
     ld (DIBUJOACTUAL), hl

     xor a
     ld (COORDENADAS + 1), a

     jp ED_MOVESL_EXIT



     EDMOVESL_4_2:        ; 4 DERECHA

     ld a, (JOYSTICK)
     bit 0, a
     jp z, EDMOVESL_4_3

     ld a, (ED_SLACT)
     bit 0, a
     jp nz, CICLOEDITOR ; jp nz, ED_MOVESL_EXIT
     inc a
     ld (ED_SLACT), a

     ld hl, (DIBUJOACTUAL)
     ld de, 32
     add hl, de
     ld (DIBUJOACTUAL), hl

     xor a
     ld (COORDENADAS), a

     jp ED_MOVESL_EXIT


     EDMOVESL_4_3:        ; 4 IZQUIERDA

     ld a, (JOYSTICK)
     bit 1, a
     jp z, ED_MOVESL_EXIT

     ld a, (ED_SLACT)
     bit 0, a
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     dec a
     ld (ED_SLACT), a

     and a
     ld hl, (DIBUJOACTUAL)
     ld de, 32
     sbc hl, de
     ld (DIBUJOACTUAL), hl

     ld a, #0f
     ld (COORDENADAS), a

     jp ED_MOVESL_EXIT


     ED_MOVESL_9:


     ; 9 ARRIBA

     ld a, (JOYSTICK)
     bit 3, a
     jp z, EDMOVESL_9_1

     ld a, (ED_SLACT)
     cp 3
     jp c, CICLOEDITOR ; jp c, ED_MOVESL_EXIT
     sub 3
     ld (ED_SLACT), a

     ld hl, (DIBUJOACTUAL)
     ld de, 96
     sbc hl, de
     ld (DIBUJOACTUAL), hl

     ld a, #0f
     ld (COORDENADAS + 1), a

     jp ED_MOVESL_EXIT


     EDMOVESL_9_1:        ; 9 ABAJO

     ld a, (JOYSTICK)
     bit 2, a
     jp z, EDMOVESL_9_2

     ld a, (ED_SLACT)
     cp 6
     jp nc, CICLOEDITOR ; jp nc, ED_MOVESL_EXIT
     add a, 3
     ld (ED_SLACT), a

     ld hl, (DIBUJOACTUAL)
     ld de, 96
     add hl, de
     ld (DIBUJOACTUAL), hl

     xor a
     ld (COORDENADAS + 1), a

     jp ED_MOVESL_EXIT


     EDMOVESL_9_2:        ; 9 DERECHA

     ld a, (JOYSTICK)
     bit 0, a
     jp z, EDMOVESL_9_3

     ld a, (ED_SLACT)
     cp 2
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     cp 5
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     cp 8
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     inc a
     ld (ED_SLACT), a

     ld hl, (DIBUJOACTUAL)
     ld de, 32
     add hl, de
     ld (DIBUJOACTUAL), hl

     xor a
     ld (COORDENADAS), a

     jp ED_MOVESL_EXIT


     EDMOVESL_9_3:        ; 9 IZQUIERDA

     ld a, (JOYSTICK)
     bit 1, a
     jp z, ED_MOVESL_EXIT

     ld a, (ED_SLACT)
     and a
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     cp 3
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     cp 6
     jp z, CICLOEDITOR ; jp z, ED_MOVESL_EXIT
     dec a
     ld (ED_SLACT), a

     and a
     ld hl, (DIBUJOACTUAL)
     ld de, 32
     sbc hl, de
     ld (DIBUJOACTUAL), hl

     ld a, #0f
     ld (COORDENADAS), a


     ED_MOVESL_EXIT:


     ld e, PAPER_CYAN
     ld d, #3f
     ld (ATTR_ACT), de
     call ED_VIEW

     ld d, PAPER_MAGENTA
     ld e, 8
     ld bc, #ffff
     call DRAWSELECTOR

     call DRAWCURSOR

     call EDITOR_SHOWSL

     jp CICLOEDITOR

SETBIT:
       push af                   ; Subimos AF para salvaguardar el Carry
       ld hl, DIBUJOACTUAL       ; Primero ponemos HL apuntando al dibujo actual (En DIBUJOACTUAL hay un puntero hacia el dibujo actual)
       ld e, (hl)
       inc hl
       ld d, (hl)
       ex de, hl

       ld a, b                   ; Nos piden la parte de arriba?
       cp 8
       jp c, SB_Salto1           ; Si es as, vamos a buscar la columna

       ld de, 16                 ; Hay que aumentar el puntero 16 bytes
       add hl, de

       sub 8                     ; Y restar 8 de la fila, para saber en qu fila del caracter estamos

       SB_Salto1:

       ld e, a                   ; Aumentamos el puntero tantos bytes
       ld d, 0                   ; como el nmero de fila que tengamos que buscar
       add hl, de


       ld a, c                   ; Nos piden la parte de la izquierda?
       cp 8
       jp c, SB_Salto2           ; Si es as, ya tenemos HL en su sitio

       ld de, 8                  ; Si no, hay que aumentar 8 bytes, para pasar al caracter de la derecha
       add hl, de

       SB_Salto2:

       ld e, #80                 ; Preparamos la mscara con el bit 7 a 1

       ld a, c                   ; Cargamos en A el bit que nos piden, para ajustarlo al byte sin modificar la columna

       cp 8                      ; Pertenece al segundo byte?
       jr c, SETBIT_PrimeraParte ; NO: No hay que hacer nada, el n de la columna indica el n de bit
       sub 8                     ; SI: Hay que restar 8, para que el n de la columna indique el n de bit

SETBIT_PrimeraParte:
       and a                     ; Miras el byte 7? (que es la columna 0 de ese byte)
       jr z, SETBIT_ColOK        ; SI: Tienes la mscara bien

       SETBIT_Bucle2:            ; NO: Ajustamos la mscara E
            srl e                ; Corrindola a la derecha
            dec a                ; Tantas veces como el nmero de columna
            jr nz, SETBIT_Bucle2

SETBIT_ColOK                     ; Ya tenemos HL en el byte a valorar y E con la mscara bien hecha
       pop af
       jp c, SETBIT_Set

       ld a, (hl)                ; Cargamos en A lo que haya en HL
       and e
       ret z

       ld a, (hl)                ; Cargamos en A lo que haya en HL
       xor e
       ld (hl), a

       ret


SETBIT_Set:
       ld a, (hl)                ; Cargamos en A lo que haya en HL
       or e                      ; Le hacemos un AND con la mscara
       ld (hl), a                ; lo volvemos a su sitio

       scf
       ret

ED_VIEW:
     ld bc, #0f0f                                     ; Empezamos en Fila 15, Columna 15

ED_VIEW_BUCLE:

      call RETBIT                                     ; Valoramos el bit que toque

      jr nc, ED_VIEW_Blanco                              ; Si es Cero, nos hay que ponerlo en blanco

      ld a, MARCA                                     ; si no, hay que ponerlo en negro
      jp ED_VIEW_Print                                   ; Vamos a imprimirlo

ED_VIEW_Blanco:
      ld a, BLANCO2                                    ; Lo ponemos en blanco

ED_VIEW_Print:
      call DRAWSQUARE                                 ; Pinta el cuadrado, en funcin de lo que tengas en A

      dec c                                           ; Siguiente columna para abajo
      jp p, ED_VIEW_BUCLE                                ; Si no te has pasado del 0, no hay que empezar nueva fila

      ld c, #0f                                       ; Nueva fila: Empezamos en la columna 15
      dec b                                           ; Y decrementamos la fila

      jp p, ED_VIEW_BUCLE                                ; Si no te has pasado del 0, todava no has terminado

      ret                                             ; Vulvete, que ya has terminado

; MUEVESELECTOR: Mueve el selector a donde sea necesario
; ENTRADA: BC: Desplazamiento horizontal y vertical
; Utiliza DE, HL, AF y mantiene BC

ED_MUEVESELECTOR:

     ld a,b                                        ; Si BC = 0, nos volvemos, porque no hay que moverse
     or c
     ret z

     push bc

     ld d, PAPER_CYAN                              ; Y ahora dentro del tablero
     ld e, 8
     ld bc, #ffff
     call DRAWSELECTOR                             ; Y a pintar, es decir, borrarlo

     pop bc                                        ; Recuperamos nuestro BC

     ld hl, COORDENADAS                            ; Aplicamos el desplazamiento: Primero a las columnas
     ld a, (hl)
     add a, c
     ld (hl), a

     inc hl                                        ; Y luego a las filas
     ld a, (hl)
     add a, b
     ld (hl), a

     ld hl, PUEDEDISPARAR                          ; Como nos hemos movido, ya podemos volver a "disparar"
     ld (hl), 1


     ld d, PAPER_MAGENTA                              ; Y ahora dentro del tablero
     ld e, 8
     ld bc, #ffff
     call DRAWSELECTOR                             ; Y a pintar, es decir, borrarlo

     ld a, (MODOCURSOR)
     call DRAWCURSOR

     ret                                           ; et voil!

ED_NOFUEGO:
     ld a, 1
     ld (PUEDEDISPARAR), a

     call RESETMODOCURSOR

     jp CICLOEDITOR

ED_FUEGO:
     ld hl, PUEDEDISPARAR
     ld a, (hl)
     and a
     jp z, CICLOEDITOR

     xor a
     ld (hl), a

     ld bc, (COORDENADAS)
     push bc

     call RETMODOCURSOR
     and a
     jp nz, ED_FUEGO1


     pop bc
     push bc

     call RETBIT
     ccf

     ld a, 0
     rl a

     and a
     jp nz, ED_FUEGO1

     ld a, 2

     ED_FUEGO1:

     call SETMODOCURSOR
     rr a

     pop bc
     push bc

     call SETBIT

     ld a, MARCA
     jp c, ED_FUEGO_DIBUJA

     ld a, BLANCO2

ED_FUEGO_DIBUJA:
     pop bc

     ld hl, ATTR_ACT + 1
     ld (hl), #3f                                     ; y vamos a respetar el brillo y flash que haya

     call DRAWSQUARE

     ld a, (MODOCURSOR)
     call DRAWCURSOR

     ld bc, #0010
     ld (VAR3), bc

     ld e, d
     ld d, #00
     ld (ATTR_ACT), de
     call DPEQUE1

     call CUENTABLANCOS
     ld a, (BLANCOSNIVEL)
     and a
     jp z, ED_SHOWWARNING

     xor a
     ld (ATTR_ACT), a
     ld a, #ff
     ld (ATTR_ACT+1), a
     ld bc, #1512
     ld hl, STR_LINEAENBLANCO + 20
     call PRINTSTR
     ld bc, #1612
     ld hl, STR_LINEAENBLANCO + 20
     call PRINTSTR
     ld bc, #1712
     ld hl, STR_LINEAENBLANCO + 20
     call PRINTSTR

     jp CICLOEDITOR+2


ED_EDITOR:
     ld a, (ED_NUMLEV)
     and a
     jp z, EDMENU_Ciclo

     xor a
     ld (ED_SLACT), a
     ld (COORDENADAS), a
     ld (COORDENADAS + 1), a

     ld de, LEVELDATA + 1
     ld (DIBUJOACTUAL), de

     ld hl, GFX_EDMARCO
     call DEPACK_SCR

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_ED_TOGGLE
     ld bc, #0a12
     call PRINTSTR

     inc hl
     ld bc, #1212
     call PRINTSTR

     inc hl
     ld bc, #0e12
     call PRINTSTR

     ld hl, STR_ED_TO
     ld bc, #091a
     call PRINTSTR

     ld hl, STR_ED_TO
     ld bc, #0d1a
     call PRINTSTR

     ld hl, STR_ED_TO
     ld bc, #111a
     call PRINTSTR

     ld hl, STR_LEVELN
     ld bc, #0403
     call PRINTSTR

     ld a, (ED_LEVACT)
     ld d, 0
     ld e, a
     ld bc, #040a
     call PRINTNUM

     ld a, '/'
     ld bc, #040b
     call PRINTCHR

     ld e, PAPER_BLACK | INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_ED_FIRE
     ld bc, #0914
     call PRINTSTR

     inc hl
     ld bc, #1114
     call PRINTSTR

     inc hl
     ld bc, #0d14
     call PRINTSTR

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_MENU4 + 3
     ld bc, #0102
     call PRINTSTRX2

     call ED_ACTIVABANK
     ld a, (ED_LEVACT)
     call DUMPLEVEL
     call ED_DESACTIVABANK


     ld a, (LEVEL_DATA)
     ld (SUBNIVELES), a
     ld (SUBNIVELACT), a

     ld de, LEVEL_DATA + 1                                ; Cogemos el nmero de subniveles

     ld hl, DIBUJOACTUAL                           ; Para meterlo en la variable DIBUJOACTUAL
     ld (hl), e
     inc hl
     ld (hl), d

     ld e, PAPER_CYAN | INK_BLACK                    ; Y vamos a pintar de papel cyan y tinta negra
     ld d, #3f                                        ; y vamos a respetar el brillo y flash que haya
     ld (ATTR_ACT), de

     call ED_VIEW

     ld d, PAPER_MAGENTA
     ld e, 8
     ld bc, #ffff
     call DRAWSELECTOR

     call EDITOR_SHOWSL

     CICLOEDITOR:

      halt
      halt
      halt
      halt
      halt

     ld hl, CONTROLS + 5
     ld a, (hl)
     call KTEST1
     jp nc, ED_CLEAR_BOARD

     ld hl, CONTROLS + 6
     ld a, (hl)
     call KTEST1
     jp nc, EXIT_EDITOR

     call READ_JOYSTICK

     scf

     ld a, (JOYSTICK)
     bit 2, a
     call nz, BAJA
     jp nc, ED_MOVESL

     ld a, (JOYSTICK)
     bit 3, a
     call nz, SUBE
     jp nc, ED_MOVESL

     ld a, (JOYSTICK)
     bit 0, a
     call nz, DERECHA
     jp nc, ED_MOVESL

     ld a, (JOYSTICK)
     bit 1, a
     call nz, IZQUIERDA
     jp nc, ED_MOVESL

     ld b,d
     ld c,e
     call ED_MUEVESELECTOR

     ld a, (JOYSTICK)
     bit 4, a
     jp z, ED_NOFUEGO
     jp nz, ED_FUEGO

EXIT_EDITOR:
     ld a, (BLANCOSNIVEL)
     and a
     jp z, CICLOEDITOR

     call SAVE_SCR

     ld de, #ff00
     ld (ATTR_ACT), de

     ld bc, #1700

     EXIT_CLS_Bucle:
     ld hl, STR_LINEAENBLANCO + 16
     call PRINTSTR
     ld c, 0
     dec b
     ld a, b
     cp 7
     jp nz, EXIT_CLS_Bucle

     call ED_ACTIVABANK

     ld hl, $c000
     ld a, (ED_LEVACT)
     ld e, a
     ld d, l
     add hl, de
     add hl, de
     ld e, (hl)
     inc hl
     ld d, (hl)

     push de

     ld bc, #0901
     ld (VAR3), bc
     ld e, PAPER_MAGENTA
     ld d, #ff
     ld (ATTR_ACT), de

     call DPEQ_DrawSquare

     pop de
     push de
     inc de

     call DPEQUE2
     
     call ED_DESACTIVABANK

     ld bc, #0909
     ld e, PAPER_YELLOW
     call DIBUJAPEQUE

     pop de
     ld (VAR3), de

     ld e, INK_CYAN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_ED_EXITOP
     ld bc, #1103
     call PRINTSTR

     ld e, INK_CYAN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     inc hl
     ld bc, #1301
     call PRINTSTR

     inc hl
     ld bc, #1401
     call PRINTSTR

     inc hl
     ld bc, #1501
     call PRINTSTR

     ED_EXIT_WFK:

     call KFIND

     cp KEY_1
     jp z, EDMENU
     cp KEY_2
     jp z, ED_CONTEDIT
     cp KEY_0
     jp nz, ED_EXIT_WFK

     call ED_ACTIVABANK

     ld de, (VAR3)

     ld hl, LEVEL_DATA

     ld a, (hl)

     ld b, 0

     sla a
     rl b
     sla a
     rl b
     sla a
     rl b
     sla a
     rl b
     sla a
     rl b
     ld c, a                          ; BC = A *32

     inc bc

     ldir

     jp EDMENU
     

ED_CONTEDIT:

     call LOAD_SCR
     jp CICLOEDITOR

ED_CLEAR_BOARD
     ld bc, $0f0f

     ED_CLRBOARD_Bucle:

     push bc

     and a
     call SETBIT

     ld a, BLANCO2

     pop bc

     ld l, PAPER_CYAN
     ld h, 0
     ld (ATTR_ACT), hl                                     ; y vamos a respetar el brillo y flash que haya

     call DRAWSQUARE

     dec b
     jp p, ED_CLRBOARD_Bucle

     ld b, $0f
     dec c
     jp p, ED_CLRBOARD_Bucle

     ld bc, #0010
     ld (VAR3), bc

     ld e, d
     ld d, #00
     ld (ATTR_ACT), de
     call DPEQUE1

     call CUENTABLANCOS
     jp ED_SHOWWARNING
