; --------------------------------------------------------------------------------------------
; iLogicAll
; (c) 2.007 - 2.008 CEZGS
; Code by Luis I. Garca - a.k.a. Benway
;
; My first asm game!!! :)
;
; I would dedicate this code to the loving
; memory of my father and my mother-in-law.
; Both became sick and passed away during
; the game development. I hope you like
; this little tribute, wherever you are.
; --------------------------------------------------------------------------------------------

; --------------------------------------------------------------------------------------------

include "songs.sym"
include "levels.sym"
include "screens.sym"
; --------------------------------------------------------------------------------------------

ORG 25000

ILOGICALL
     jp ILOGIC_INIT

; --------------------------------------------------------------------------------------------
include "screen.asm"
include "data.asm"
include "uncrunch.asm"
include "vortex.asm"
include "menu.asm"
include "editor.asm"
include "math.asm"
include "keyboard.asm"
; --------------------------------------------------------------------------------------------

ILOGIC_INIT:

     ld sp, 24000                           ; La pila en 24000

     xor a
     out (#fe), a
     ld e, PAPER_BLACK | INK_BLACK
     ld d, #ff
     ld (ATTR_ACT), de
;     call CLS

     ld a, #fe                           ; Activamos las interrupciones, cuya tabla tenemos desde #fe00 a #ff00
     ld i, a
     im 2

     ld de, 0
     ld (VAR3), de

;     ld hl, GFX_LOADING
;     call DEPACK_SCR

     call WAITFORKEY

     call ESPIRAL

     call ED_RESET

     ld hl, GFX_CEZGS
     call DEPACK_SCR

     ld b, 150
     call PAUSE

     call FADE_OUT
     ld hl, $4800
     ld a, 0
     ld bc, $800
     call SETMEM

     call MUTE
     ld hl, MUS_INTRO
     call START

     call SHOWINTRO

     call UNPACK_MENU

     jp CICLOPPAL

; SETRAMBANK: Activa la pgina de RAM especificada en el registro B
; Entrada: B -> Pgina a activar
; Utiliza: AF y BC

SETRAMBANK:
     ld  a, ($5B5C)
     and $F8
     or  b
     ld  bc, $7FFD
     ld  ($5B5C), a
     out (c), a
     ret

SHOWINTRO:

     call SHOWCP
     ld hl, STR_VIN_INTRO1
     ld bc, #0200
     ld a, 33
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO2
     ld bc, #0300
     ld a, 33
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO3
     ld bc, #0a00
     ld a, 81
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO4
     ld bc, #0b00
     ld a, 81
     call PRINTSTR_6X8
     ld b, 250
     call PAUSE

     call SHOWCP
     ld hl, STR_VIN_INTRO5
     ld bc, #0D00
     ld a, 41
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO6
     ld bc, #0E00
     ld a, 41
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO7
     ld bc, #1000
     ld a, 57
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO8
     ld bc, #1100
     ld a, 51
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO9
     ld bc, #1200
     ld a, 65
     call PRINTSTR_6X8
     ld b, 250
     call PAUSE

     call SHOWCP
     ld hl, STR_VIN_INTRO10
     ld bc, #0400
     ld a, 160
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO11
     ld bc, #0500
     ld a, 160
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO12
     ld bc, #0600
     ld a, 160
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO13
     ld bc, #0700
     ld a, 160
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO14
     ld bc, #0F00
     ld a, 129
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO15
     ld bc, #1000
     ld a, 129
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO16
     ld bc, #1100
     ld a, 129
     call PRINTSTR_6X8
     ld b, 250
     call PAUSE

     call SHOWCP
     ld hl, STR_VIN_INTRO17
     ld bc, #0700
     ld a, 65
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO18
     ld bc, #0800
     ld a, 65
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO19
     ld bc, #0900
     ld a, 65
     call PRINTSTR_6X8
     ld b, 250
     call PAUSE


     call SHOWCP
     ld hl, STR_VIN_INTRO20
     ld bc, #1100
     ld a, 113
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO21
     ld bc, #1200
     ld a, 113
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO22
     ld bc, #1300
     ld a, 113
     call PRINTSTR_6X8
     ld hl, STR_VIN_INTRO23
     ld bc, #1400
     ld a, 113
     call PRINTSTR_6X8
     ld b, 250
     call PAUSE

     call MUTE
     call FADE_OUT
     ret


CICLOPPAL:

     call MENU                              ; Enseamos el men
     call CORTINILLA

     call MUTE

     call INITLEVEL                         ; Inicializamos el primer nivel

     call CICLOJUEGO                        ; Saltamos al juego

     RM_HOOK:

     call MUTE

     call POSTGAME

     call MENU_CLSTXT

     ld de, #ffff
     ld (VAR3), de

     jp CICLOPPAL                           ; Y repetimos hasta el infinito... y ms all!

;     ret ; RETORNARIA A BASIC :?

; SETMEM: Llena una zona de la memoria de un valor determinado
; ENTRADA: HL direccin de comienzo
;          A Valor a poner
;          BC nmero de octetos a llenar
SETMEM:

     ld (hl), a
     ld d, h
     ld e, l
     inc de
     ldir
     ret

CNUMBERS_ENDED:

     push bc
     call CHECKCOLENDED
     pop bc

     ret nz

     ld hl, ATTR_ACT

     ld a, (hl)

     srl a
     srl a
     srl a
     cpl
     and 1
     ld d, a

     ld a, (hl)
     and 8
     or d

     ld e, a
     ld d, #ff
     ld (ATTR_ACT), de

     ret


; CNUMBERS: Colorea de papel blue y black alternativamente la zona de los nmeros de "pista"
; Entrada: BC: Si coloreamos fila (B != 0) o columna (C != 0) ... o las dos cosas
; Utiliza BC, DE, HL y A

MINI_CNUMBERS:
     push bc                                 ; Nos guardamos BC, que ms alante lo usamos para ver si hay que colorear las filas
     ld a, c                                 ; Vamos a ver si C es 0...
     and a
     jr z, MINICNUMBS_Fila                   ; ... y, si lo es, te saltas a ver si coloreams las filas

     ld b, #07                               ; Empezamos en fila 7
     ld hl, COORDENADAS
     ld c, (hl)

;     MINICNUMBERS_CNext:

     ld e, PAPER_BLUE | INK_WHITE            ; Y empezamos a pintar de azul
     ld d, #ff
     ld (ATTR_ACT), de

     bit 0, c                                ; Es un nmero par?
     call z, CNUMBERS_SPaperColor            ; Si lo es, cambia el color del papel

     call CNUMBERS_ENDED

     MINICNUMBERS_CPPrint:

     ld hl, ATTR_ACT                         ; Coge en D el valor del atributo actual
     ld d, (hl)

     call ATT_LOCATE                         ; Y ponlo en la casilla actual, sealada por BC
     ld (hl), d
     dec b                                   ; Decrementamos B (filas) ... dentro de la misma columna
     jp p, MINICNUMBERS_CPPrint              ; Y, si sigue siendo positivo, nos vamos a la siguiente fila...



     MINICNUMBS_Fila:

     pop bc                                  ; Recuperamos BC
     ld a, b                                 ; Es B distinto de 0? Tenemos que pintar las filas?
     and a
     ret z                                   ; Si es 0, ya hemos terminado

     ld c, #10                               ; Empezamos en Columna 16
     ld hl, COORDENADAS+1
     ld a, (hl)
     add a, 8
     ld b, a


;     MINICNUMBERS_FNext:

     ld e, PAPER_BLUE | INK_WHITE            ; Empezamos pintando de azul
     ld d, #ff
     ld (ATTR_ACT), de

     bit 0, b                                ; Estamos en una fila par?
     call z, CNUMBERS_SPaperColor            ; Si lo es, cambia el color del papel

     push bc
     ld a, -8
     add a, b
     ld b, a
     call CHECKFILAENDED
     pop bc

     jp nz, MINICNUMBERS_FPrint

     ld hl, ATTR_ACT

     ld a, (hl)
     srl a
     srl a
     srl a
     cpl
     and 1
     ld d, a

     ld a, (hl)
     and 56
     or d

     ld e, a
     ld d, #ff
     ld (ATTR_ACT), de

     MINICNUMBERS_FPrint:

     ld hl, ATTR_ACT                         ; Coge en D el atributo actual
     ld d, (hl)
     call ATT_LOCATE                         ; Y ponlo en las coordenadas actuales
     ld (hl), d
     inc c                                   ; Siguiente columna de esta fila
     ld a, c                                 ; Si no hemos llegado a la columna 24
     cp 24
     jr nz, MINICNUMBERS_FPrint                   ; Seguimos pintando la misma fila

     ret                                     ; Si hemos llegado, nos volvemos



CNUMBERS_SPaperColor:
     ld e, PAPER_BLACK | INK_WHITE           ; Vamos a pintar de papel negro
     ld d, #ff
     ld (ATTR_ACT), de
     ret




VIEW:
     call MUTE

     ld bc, #ffff
     call MINI_CNUMBERS

     ld bc, #0f0f                                     ; Empezamos en Fila 15, Columna 15

VIEW_BUCLE:

      call RETBIT                                     ; Valoramos el bit que toque

      jr nc, VIEW_Blanco                              ; Si es Cero, nos hay que ponerlo en blanco

      ld e, PAPER_YELLOW | INK_BLACK                     ; Y vamos a pintar de papel cyan y tinta negra
      ld d, #3f                                        ; y vamos a respetar el brillo y flash que haya
      ld (ATTR_ACT), de

      ld a, NEGRO                                     ; si no, hay que ponerlo en negro
      jp VIEW_Print                                   ; Vamos a imprimirlo

VIEW_Blanco:
      ld e, PAPER_YELLOW | INK_BLACK                     ; Y vamos a pintar de papel cyan y tinta negra
      ld d, #3f                                        ; y vamos a respetar el brillo y flash que haya
      ld (ATTR_ACT), de
      ld a, BLANCO                                    ; Lo ponemos en blanco

VIEW_Print:
      call DRAWSQUARE                                 ; Pinta el cuadrado, en funcin de lo que tengas en A

      dec c                                           ; Siguiente columna para abajo
      jp p, VIEW_BUCLE                                ; Si no te has pasado del 0, no hay que empezar nueva fila

      ld c, #0f                                       ; Nueva fila: Empezamos en la columna 15
      dec b                                           ; Y decrementamos la fila

      jp p, VIEW_BUCLE                                ; Si no te has pasado del 0, todava no has terminado

      ret                                             ; Vulvete, que ya has terminado


; DRAWSQUARE: Dibuja el cuadrado de las coordenadas BC en el estado A
; Entrada:
; BC: Coordenadas: B = Fila, C = Columna
; A: Estado del cuadrado: 0 = Cerrado, 1 = Blanco, 2 = Marca, 3 = Negro
; Mantiene BC (lo sube a la pila y lo recupera)
; Utiliza HL, DE, y A

DRAWSQUARE:
        ld h, 0                        ; Ponemos en HL el valor de A (El cuadrado que buscamos)
        ld l, a

        add hl, hl                     ; Lo multiplicamos por 8 (cada dibujico ocupa 8 bytes)
        add hl, hl
        add hl, hl

        ld de, GFX_CCerrado            ; GFX_CCerrado es el primero, el que corresponde con A = 0
        add hl, de                     ; Se lo aadimos a HL
        ex de, hl                      ; Y pasamos a DE el resultado

        push bc                        ; Nos guardamos BC, porque vamos a guarrear, y lo vamos a mantener en la rutina

        ld a, b                        ; Ajustamos la coordenada: Fila = Pxel + 8
        add a, 8
        ld b, a                        ; La fila del pxel que sea, ms 8

        call PRINT                     ; Llamamos a PRINT, que va a dibujar en BC los 8 bytes que seale DE

        pop bc                         ; Recuperamos BC

        ret                            ; Nos volvemos...

; SETSTATUS: Pone en el estado del bit BC dentro del dibujo lo contenido en el acumulador
; Entrada:
; BC = Pxel a cambiar; B = Fila C = Columna
; A = Estado a poner: 0 = Cerrado, 1 = Blanco, 2 = Marca, 3 = Negro
; Utiliza HL
; Mantiene BC

SETSTATUS:

   push af                            ; Nos guardamos el Acumulador: Tenemos que guarrear con l

   call RETSTATUS                     ; Llama a RETSTATUS: Esto se carga AF (Nos pone en A el estado actual),

   pop af                             ; Recupera AF
                                      ; pero nos deja HL apuntando al lugar correcto de la tabla para estas coordenadas
;   SETS_Bit:
   ld (hl), a                         ; Y escribe el estado que sea en la tabla

   ret                                ; Has terminado



; RETSTATUS: Devuelve en el acumulador el estado del bit BC dentro del dibujo
; Entrada:
; BC = Pxel a valorar; B = Fila C = Columna
; Salida:
; A = Estado del bit: 0 = Cerrado, 1 = Blanco, 2 = Marcado, 3 = Negro
; Utiliza:
; HL, DE
; Mantiene BC

RETSTATUS:

   ld hl, ESTADOTABLERO               ; Apuntamos a la tabla de estado del tablero

   ld a, b                            ; Hay que ajustar el puntero al byte concreto
   and a                              ; Si nos piden la fila 0, de momento, ya estamos
   jr z, RETS_Columna                 ; As que vete a ajustar la columna

   RETS_FilaB:

   push de

   ld de, 16
   add hl, de                         ; Por cada fila que sea, hay que incrementar 16 bytes el puntero hl

   pop de

   dec a                              ; Hemos llegado ya a la fila?
   jr nz, RETS_FilaB                  ; Si no, sigue sumando

   RETS_Columna:

   ld a, c                            ; Nos piden la columna 0?
   and a                              ; Si es as, tenemos HL apuntando correctamente
   jr z, RETS_Bit                     ; As que, vete a escribir directamente

   RETS_ColumnaB:

   inc hl                             ; Aumenta un byte
   dec a                              ; por cada fila que haya
   jr nz, RETS_ColumnaB               ; hasta que llegues


   RETS_Bit:
   ld a, (hl)

   ret



; RETBIT: Devuelve en el carry el estado del bit BC dentro del dibujo actual
; Entrada:
; BC = Pxel a valorar; B = Fila C = Columna
; Salida
; CarryFlag = Bit
; Mantiene BC
; Usa A y DE
RETBIT:
       ld hl, DIBUJOACTUAL       ; Primero ponemos HL apuntando al dibujo actual (En DIBUJOACTUAL hay un puntero hacia el dibujo actual)
       ld e, (hl)
       inc hl
       ld d, (hl)
       ex de, hl

       ld a, b                   ; Nos piden la parte de arriba?
       cp 8
       jp c, RB_Salto1           ; Si es as, vamos a buscar la columna

       ld de, 16                 ; Hay que aumentar el puntero 16 bytes
       add hl, de

       sub 8                     ; Y restar 8 de la fila, para saber en qu fila del caracter estamos

       RB_Salto1:

       ld e, a                   ; Aumentamos el puntero tantos bytes
       ld d, 0                   ; como el nmero de fila que tengamos que buscar
       add hl, de


       ld a, c                   ; Nos piden la parte de la izquierda?
       cp 8
       jp c, RB_Salto2           ; Si es as, ya tenemos HL en su sitio

       ld de, 8                  ; Si no, hay que aumentar 8 bytes, para pasar al caracter de la derecha
       add hl, de

       RB_Salto2:

       ld e, #80                 ; Preparamos la mscara con un 1 en el bit 7

       ld a, c                   ; Cargamos en A el bit que nos piden, para ajustarlo al byte sin modificar la columna

       cp 8                      ; Pertenece al segundo byte?
       jr c, RETBIT_PrimeraParte ; NO: No hay que hacer nada, el n de la columna indica el n de bit
       sub 8                     ; SI: Hay que restar 8, para que el n de la columna indique el n de bit

RETBIT_PrimeraParte:
       and a                     ; Miras el byte 7? (que es la columna 0 de ese byte)
       jr z, RETBIT_ColOK        ; SI: Tienes la mscara bien

       RETBIT_Bucle2:            ; NO: Ajustamos la mscara E
            srl e                ; Corrindola a la derecha
            dec a                ; Tantas veces como el nmero de columna
            jr nz, RETBIT_Bucle2

RETBIT_ColOK                     ; Ya tenemos HL en el byte a valorar y E con la mscara bien hecha
       ld a, (hl)                ; Cargamos en A lo que haya en HL
       and e                     ; Hacemos un AND con la mscara
       jr z, RETBIT_Es0          ; Si CERO, slta a Es0 para devolver un 0 en A
       scf                       ; Es UNO, as que setea el carry
       ret                       ; Y vulvete
RETBIT_Es0
       and a                     ; Limpia el carry
       ret                       ; Y vulvete



; ADJUSTNUM: Calcula e imprime los numeritos: El nmero de bits "0" que hay en el dibujo
; Entrada:
; DE: D = Fila / Columna , E = 0 para fila !=0 para columna
; Utiliza:
; DE, BC, HL, IX e IY
ADJUSTNUM:
       ld a, 0
       ld (ATTR_ACT + 1), a

       ld ix, BFNUMBERS                  ; Primero borramos los datos anteriores
       ld iy, BFNUMBERS                  ; Vamos a modificar IX, as que nos dejamos "una copia" aqu para usarlo de contador para las filas
       ld (ix), 0
       ld (ix + 1), 0
       ld (ix + 2), 0
       ld (ix + 3), 0
       ld (ix + 4), 0
       ld (ix + 5), 0
       ld (ix + 6), 0
       ld (ix + 7), 0
       ld (ix + 8), 0
       ld (ix + 9), 0

       ld a, e                           ; Fila o columna?
       and a

       jr z, ADJFila

       ; AJUSTAR LA COLUMNA d: Vamos a empezar desde abajo, porque vamos a imprimir desde abajo

       ld c, d                    ; Vamos a mirar la columna d
       ld b, 15                   ; Desde la ltima fila

       ld e, 0                    ; Vamos a usar E como contador de CEROS

       ADJ_BUCLECol:
            inc e
            push de               ; RETBIT modifica DE
            call RETBIT           ; Metemos en el carry el bit del dibujo
            pop de                ; Recuperamos "Nuestro" DE

            call c, ADJSave       ; Si es un UNO, el acumulador tiene un 0, as que tras hacer un AND A, se activa el flag ZERO: Guardamos el valor de E

            dec b
            jp p,ADJ_BUCLECol          ; Pasamos a la siguiente fila

        inc e                      ; Hay que incrementar uno el ltimo valor
        call ADJSave               ; Grabamos el ltimo valor

       ; AHORA VAMOS A IMPRIMIR el resultado

       ld b, 7                    ; La fila 7 (que es la octava)
       ld c, d                    ; y la columna que tenamos en D
                                  ; YA TENEMOS BC CON LAS COORDENADAS

       ld ix, BFNUMBERS           ; Restauramos el puntero IX

       ADJCol_BUCLEPrint:

           call ADJ_CaractNumPRINT

           inc ix                     ; Vamos a valorar el siguiente nmero
           ld a, (ix)                 ; Lo cargamos en A
           and a                      ; Vamos a valorar si es 0
           ret z                      ; Si es 0, nos volvemos ya                                   <<<<<<< RETORNO

           dec b                      ; Si no es 0, nos pasamos a la siguiente fila
           jp ADJCol_BUCLEPrint       ; Saltamos al bucle


ADJFila:
       ; AJUSTAR LA FILA d: Vamos a empezar desde abajo, porque vamos a imprimir desde abajo

       ld b, d                    ; Vamos a mirar la fila d
       ld c, 15                   ; Desde la ltima columna

       ld e, 0                    ; Vamos a usar E como contador de CEROS

       ADJ_BUCLEFil:
            inc e
            push de
            call RETBIT          ; Metemos en el carry el bit del dibujo
            pop de

            call c, ADJSave      ; Si es un UNO: Guardamos el valor de E

            dec c
            jp p,ADJ_BUCLEFil          ; Pasamos a la siguiente fila

       inc e
       call ADJSave               ; Grabamos el ltimo valor

       ; AHORA VAMOS A IMPRIMIR el resultado

       ld c, 16                   ; La columna que es
       ld a, 8
       add a, d
       ld b, a                    ; y la fila que tenamos en D
                                  ; YA TENEMOS BC CON LAS COORDENADAS

       ld ix, BFNUMBERS           ; Restauramos el puntero IX

       ld a,(iy+9)                ; Ajustamos la coordenada de la columna para empezar a escribir por la derecha
       and a                      ; Si no hay ninguno, empezamos en la 16 directamente
       jr z, ADJFil_BUCLEPrint
       add a,c                    ; Si hay, lo aadimos a la columna
       ld c,a
       dec c                      ; Y empezamos uno ms atrs ?


       ADJFil_BUCLEPrint:

           call ADJ_CaractNumPRINT

           inc ix                     ; Vamos a valorar el siguiente nmero
           ld a, (ix)                 ; Lo cargamos en A
           and a                      ; Vamos a valorar si es 0
           ret z                      ; Si es 0, nos volvemos ya                                   <<<<<<< RETORNO

           dec c                      ; Si no es 0, nos pasamos a la siguiente fila
           jp ADJFil_BUCLEPrint       ; Saltamos al bucle

ADJ_CaractNumPRINT:
       ld h, 0
       ld l, (ix)                ; Ponemos en HL el contenido de IX (el nmero que tenemos que imprimir)
       add hl, hl                 ; Lo multiplicamos por 8 (cada carcter ocupa 8 bytes)
       add hl, hl
       add hl, hl
       ld de, GFX_Numbers         ; Ponemos en DE el origen de los caracteres de los nmeros
       add hl, de                 ; Sumamos DE a HL, y ya tenemos HL apuntando al carcter que sea
       ex de, hl                  ; Lo pasamos a DE
       call PRINT                 ; YA PODEMOS LLAMAR A PRINT
       ret                        ; YA TENEMOS DE CON EL PUNTERO AL CARCTER

ADJSave:
      dec e          ; E se incrementa al inicio del bucle
      ld a, e        ; Vamos a ver si es 0: porque haya 2 pixels "activos" seguidos
      and a          ; Y si lo es...
      ret z          ; Nos volvemos sin grabar.
      ld (ix), e     ; Grabamos en IX el contenido de E: El nmero de CEROS que hay seguidos
      inc ix         ; Incrementamos el puntero
      ld e, 0        ; Reseteamos el contador
      inc (iy + 9)
      ret            ; Volvemos


; SHOWALLNUMBERS: Pon todos los nmeros del tablero actual

SHOWALLNUMBERS:

     ld b, #10                                      ; 16 veces
     ld d, 0                                        ; Fila / Columna 0

     SAN_buc:

     ld e,1                                         ; Primero la columna D: E != 0
     push de                                        ; Nos guardamos DE: Contador de filas y columnas
     push bc                                        ; Nos guardamos BC: Por B, que es el contador del bucle
     call ADJUSTNUM                                 ; Imprimimos los nmeros de la columna actual
     pop bc                                         ; Recuperamos BC
     pop de                                         ; Y DE
     ld e,0                                         ; y ahora vamos a la fila D: E = 0
     push de                                        ; Y lo mismo que antes...
     push bc
     call ADJUSTNUM
     pop bc
     pop de
     inc d                                          ; Siguiente fila / columna

     djnz SAN_buc                                       ; y as hasta que termines el bucle

     ret



; DRAWSELECTOR: Imprime la cruceta selectora
; Entrada: DE: D lleva el color del papel en que se pinta, y E la fila en que hay que empezar a pintar
;          BC: Si B == 0 no se pinta la fila y si C == 0 no se pinta la columna
;             esplazamiento horizontal y vertical (Si se quiere pintar la cruceta entera, se pone cualquier valor !=0 en los dos)solo
; Utiliza: HL, , y
; Mantiene: BC (hace un push-pop)pasa A

DRAWSELECTOR:

    push bc                     ; Nos guardamos BC
    ld a, c                     ; Vamos a ver si C es 0
    and a
    jr z, DRAWS_FILA            ; Si lo es, no hay que pintar la columna

    DRAWS_COL:

    ld a, (COORDENADAS)         ; Cargamos la coordenada de la columna
    ld c, a
    ld b, e                     ; y la de la fila

    DRAWS_BucleC:
    call ATT_LOCATE            ; Ponemos en HL la direccin del atributo actual

    ld a, (hl)                 ; Cogemos el atributo actual
    and #40                    ; Nos quedamos con el brillo
    or d                       ; Aadimos color del papel
    ld (hl), a                 ; Y lo plantamos en la pantalla
    inc b                      ; Incrementamos el contador
    ld a,b                     ; Hemos llegado a 24?
    cp 24
    jr nz, DRAWS_BucleC        ; Si no hemos llegado, sigue bajando en esa misma columna

    DRAWS_FILA:

    pop bc                     ; Recupera BC
    push bc                    ; Y vuelve a guardar una copia
    ld a, b                    ; Y vamos a ver si B es 0
    and a
    jr z, DRAWS_Salida         ; Si lo es, no hay que pintar la fila

    ld a, (COORDENADAS + 1)    ; Y ahora vamos a por la fila
    add a, 8                   ; A la que hay que aumentar 8, porque la primera fila de casillas
    ld b, a                    ; est en la coordenada 8

    ld c, 0                    ; Empezamos por la izquierda
    call ATT_LOCATE            ; Apuntamos con HL al atributo actual

    ld a, 24                   ; Son 24 columnas las que hay que pintar
    sub e                      ; Menos el contenido de E
    ld b, a

    DRAWS_BucleF:
    ld a, (hl)                 ; Cogemos el atributo actual
    and #40                    ; Nos quedamos con el brillo
    or d                       ; Aadimos color del papel
    ld (hl), a                 ; Lo escribimos en su sitio

    inc hl                     ; Aumentamos el puntero (nos vamos al siguiente atributo hacia la derecha)
    djnz DRAWS_BucleF          ; Y si no hemos llegado a 0, seguimos pintando la siguiente columna

    DRAWS_Salida:

    ld a, e                    ; Si estamos borrando desde el editor (donde no tenemos los datos de los nmeros)
    and a                      ; y empezamos a pintar en 8, que traemos en E, nos volvemos
    pop bc
    ret nz

    push bc

    call DRAWCURSOR            ; Y ahora pintamos el cursor

    pop bc                     ; Recuperamos BC

    ret                        ; Ya est todo, nos volvemos

DELETESELECTOR:

    push bc                     ; Nos guardamos BC
    ld a, c                     ; Vamos a ver si C es 0
    and a
    jr z, DELS_FILA            ; Si lo es, no hay que pintar la columna

    DELS_COL:

    ld a, (COORDENADAS)         ; Cargamos la coordenada de la columna
    ld c, a
    ld b, 8                     ; y la de la fila

    DELS_BucleC:

    push bc

    ld d, PAPER_GREEN
    ld a, b
    sub 8
    ld b, a

    call RETSTATUS
    cp BLANCO
    jp nz, DELS_BucleC2

    ld d, PAPER_RED

    DELS_BucleC2:

    cp MARCA
    jp nz, DELSBucleC3

    ld d, PAPER_CYAN

    DELSBucleC3:

    pop bc

    call ATT_LOCATE            ; Ponemos en HL la direccin del atributo actual

    ld a, (hl)                 ; Cogemos el atributo actual
    and #40                    ; Nos quedamos con el brillo
    or d                       ; Aadimos color del papel
    ld (hl), a                 ; Y lo plantamos en la pantalla
    inc b                      ; Incrementamos el contador
    ld a,b                     ; Hemos llegado a 24?
    cp 24
    jr nz, DELS_BucleC        ; Si no hemos llegado, sigue bajando en esa misma columna

    DELS_FILA:

    pop bc                     ; Recupera BC
    push bc                    ; Y vuelve a guardar una copia

    ld a, b                    ; Y vamos a ver si B es 0
    and a
    jr z, DELS_Salida         ; Si lo es, no hay que pintar la fila

    ld a, (COORDENADAS + 1)    ; Y ahora vamos a por la fila
    add a, 8                   ; A la que hay que aumentar 8, porque la primera fila de casillas
    ld b, a                    ; est en la fila 8

    ld c, 0                    ; Empezamos por la izquierda
    call ATT_LOCATE            ; Apuntamos con HL al atributo actual

    ld a, #10                  ; Son 16 columnas las que hay que pintar
    ld b, a

    DELS_BucleF:

    push hl                    ; Guardamos HL, que "RETSTATUS" se lo carga
    push bc                    ; Vamos a trapichear con B, as que nos lo guardamos

    ld a, (COORDENADAS + 1)    ; Vamos a coger la fila "real" para mirar el estado de la casilla
    ld b, a

    ld d, PAPER_GREEN
    call RETSTATUS
    cp BLANCO
    jp nz, DELS_BucleF2

    ld d, PAPER_RED

    DELS_BucleF2:

    cp MARCA
    jp nz, DELS_BucleF3

    ld d, PAPER_CYAN

    DELS_BucleF3:

    pop bc
    pop hl

    inc c

    ld a, (hl)                 ; Cogemos el atributo actual
    and #40                    ; Nos quedamos con el brillo
    or d                       ; Aadimos color del papel
    ld (hl), a                 ; Lo escribimos en su sitio

    inc hl                     ; Aumentamos el puntero (nos vamos al siguiente atributo hacia la derecha)
    djnz DELS_BucleF          ; Y si no hemos llegado a 0, seguimos pintando la siguiente columna

    DELS_Salida:

    pop bc                     ; Recuperamos BC

    ret                        ; Ya est todo, nos volvemos

; DRAWCURSOR: Dibuja el cursor
; Utiliza: BC, D y A

DRAWCURSOR:
    ld a, d                   ; Vamos a ver que color tienes metido en D
    and #38                   ; Nos quedamos con el papel
    cp PAPER_RED              ; Es RED?
    jr nz, DRAWCURSOR00       ; Si no lo es, salta ah

    ld a, 2                   ; Pon en A un 5, que corresponde a INK_RED
    jr DRAWC_Modo0            ; Y pasa de mirar el modo activo

    DRAWCURSOR00:

    call RETMODOCURSOR        ; Pon en A el modo del cursor (Es un numero de 0 a 4)

    cp HINTMODE               ; Si no est en modo HINT
    jp nz, DRAWC_NoHint       ; Vete a pintarlo ya

    ld a, 3                   ; Si lo est, pon un 3 = magenta

    DRAWC_NoHint

    and a                     ; Es 0?
    jr nz, DRAWC_Modo0        ; Si no lo es, sltate hasta ah

    ld a, 7                   ; Si lo es, pon un 7 en A (Correspondiente a INK_WHITE)

    DRAWC_Modo0:
    
    sla a                     ; Pasalo 3 lugares a la izquierda, para tenerlo como color del papel
    sla a
    sla a
    ld d, a                   ; Gurdatelo en D

    ld a, (COORDENADAS + 1)   ; Carga las coordenadas a pintar en BC
    add a, 8                  ; Sabiendo que la fila es 8 + la fila de la coordenada
    ld b, a
    ld a, (COORDENADAS)
    ld c, a

    push de                   ; Gurdate DE, que ATT_LOCATE lo utiliza
    call ATT_LOCATE           ; Pon HL apuntando al atributo en cuestin
    pop de                    ; Recupera DE

    ld a, (hl)                ; Coge el atributo que hay
    and #c0                   ; Qudate con el brillo y dems
    or d                      ; Adele el papel
    ld (hl), a                ; Y pntalo

    ret                       ; Y ya est todo...

;RESETCLOCK: Pone a 0 el reloj
;Utiliza: IX
RESETCLOCK:
     ld ix, TICKS   ; Primero los Ticks
     ld (ix), 0     ; A 0...
     ld (ix+1), 0   ; Y ahora los Segundos...
     ld (ix+2), 0   ; Y los Minutos!
     ret


END_OF_GAME:

     ld hl, LEVELACT
     dec (hl)

     ld a, (SETTYPE)                               ; Cogemos el nivel del banco que sea, en funcin de si es el juego "original" o el "customizado"
     cp 1
     jp nz, RM_HOOK

     ld hl, GFX_THEEND
     call DEPACK_SCR

     ld hl, STR_VIN_END1
     ld bc, #0100
     ld a, 90
     call PRINTSTR_6X8
     ld hl, STR_VIN_END2
     ld bc, #0200
     ld a, 90
     call PRINTSTR_6X8
     ld hl, STR_VIN_END3
     ld bc, #0300
     ld a, 90
     call PRINTSTR_6X8

     ld hl, STR_VIN_END4
     ld bc, #0300
     ld a, 52
     call PRINTSTR_6X8
     ld hl, STR_VIN_END5
     ld bc, #0400
     ld a, 60
     call PRINTSTR_6X8

     ld hl, STR_VIN_END6
     ld bc, #0e02
     ld a, 57
     call PRINTSTR_6X8
     ld hl, STR_VIN_END7
     ld bc, #0f02
     ld a, 57
     call PRINTSTR_6X8

     ld hl, guinofin2
     ld bc, #0C1A
     ld de, #0201
     call DRAWGFX

     call MUTE
     ld hl, MUS_THEEND
     call START

     ld b, 170


     GUINOEND:

     push bc

     ld hl, VAR3
     inc (hl)
     ld a, (hl)
     cp 4
     jp nz, SALGUINOEND
     ld (hl), 0

     ld hl, GUINOEND_Act
     ld e, (hl)
     ld d, 0

     ld hl, GUINOEND_Anim
     add hl, de
     add hl, de

     ld e, (hl)
     inc hl
     ld d, (hl)

     ex de, hl

     ld bc, #0C1A
     ld de, #0201
     call DRAWGFX

     ld hl, GUINOEND_Act
     inc (hl)
     ld e, (hl)
     ld a, (GUINOEND_Ret)
     cp e
     jp nz, SALGUINOEND

     ld (hl), 0

     SALGUINOEND:

     pop bc

     halt

     djnz GUINOEND

     ld b, 50
     call PAUSE
     
     call FADE_OUT

     pop af

     jp RM_HOOK

CUENTABLANCOS:

     ld bc,#0f0f                                   ; Empezamos por fila 15, columna 15

     ld hl, BLANCOSNIVEL                           ; Ponemos a 0 el contador
     ld (hl), 0

     CB_Bucle:

     call RETBIT                                   ; Chequea el bit actual (BC)
     call nc, INITL_SumaBlanco                     ; Si vuelves sin carry, es que es una casilla blanca: Smala
     dec c                                         ; Siguiente columna
     jp p, CB_Bucle                                ; Si no te has pasado de 0, pasa a la columna siguiente

     dec b                                         ; Siguiente fila
     ret m                                         ; Si te pasas de 0, salte del bucle
     ld c, #0f                                     ; La siguiente fila, la empezamos a mirar desde la columna 15
     jp CB_Bucle                                   ; Sigue el bucle

;INITLEVEL: Inicializa el nivel actual
; Utiliza: IX, DE, HL, BC, AF

INITLEVEL:

     di
     ld a, (SETTYPE)                               ; Cogemos el nivel del banco que sea, en funcin de si es el juego "original" o el "customizado"
     ld b, a

     call SETRAMBANK

     ld a, (LEVELACT)
     call GETPUNTERONIVEL

     call ED_DESACTIVABANK

     ld a, h
     or l
     jp z, END_OF_GAME

     ld a, (MAXLEVEL)
     ld b, a
     ld a, (LEVELACT)
     cp b
     jp c, INITLEVEL_1

     ld (MAXLEVEL), a

     INITLEVEL_1:

     ld hl, SETUP                                   ; No loop en la musica
     ld (hl),1

     ld hl, GFX_INTERLEVEL
     call DEPACK_SCR

     call MUTE
     ld hl, MUS_READY
     call START


     ld de,0
     ld (ATTR_ACT), de

     ld bc, #100A                                  ; Vamos a imprimir la cadena "LEVEL: "
     ld hl, STR_LEVEL
     call PRINTSTR

     ld hl, SUBNIVELES
     ld a, (hl)
     inc hl
     ld b, (hl)
     cp b
     call z, CALCULAPUNTERO_NUEVONIVEL
     call nz, CALCULAPUNTERO_SUBNIVEL

     ld bc, #1011                                  ; Y el numero del nivel
     ld hl, LEVELACT
     ld e, (hl)
     ld d, 0
     push de                                       ; Nos guardamos el nmero de nivel ...                        <-|
                                                   ;                                                               |
     call PRINTNUM                                 ; porque PRINTNUM no guarda DE                                  |
                                                   ;                                                               |
     ld hl, SUBNIVELES+1                           ; En SUBNIVELES+1 est el nmero de subnivel actual             |
     ld e, (hl)                                    ;                                                               |
     ld d, 0                                       ;                                                               |
     ld bc, #1016                                  ;                                                               |
     call PRINTNUM                                 ; Y lo ponemos tambin en la pantalla                           |

                                                   ;                                                               |
     pop de                                        ; ... Para usarlo despus                                     <-|



     ld ix, STR_PWDPWD                             ; Vamos a general la contrasea

     ld a, e                                       ; TERCER caracter
     and #F0                                       ; 4 bits ms significativos del nmero de nivel
     srl a
     srl a
     srl a
     srl a
     add a, 'A'                                    ; Ms el carcter 'A' ('A' = 0)
     ld (ix + 2), a

     ld a, e                                       ; CUARTO caracter
     and #0F                                       ; 4 bits menos significativos del nmero de nivel
     add a, 'A'                                    ; Ms el carcter 'A' ('A' = 0)
     ld (ix + 3), a

     di
     ld a, (SETTYPE)                               ; Cogemos el nivel del banco que sea, en funcin de si es el juego "original" o el "customizado"
     ld b, a

     call SETRAMBANK

     ld hl, LEVELDATA                              ; Ahora apuntamos a la lista de punteros de niveles
     add hl, de                                    ; Le aadimos el nmero de nivel dos veces
     add hl, de                                    ; porque son dos bytes por puntero
     ld e, (hl)
     inc hl
     ld d, (hl)                                    ; Ahora DE nos apunta al inicio del nivel que sea
     inc de                                        ; Para saltarnos el nmero de subniveles
     ex de, hl                                     ; Nos lo pasamos a HL

     ld a, (hl)                                    ; SEGUNDO CARACTER: el contenido en A (Primer dato efectivo del nivel)
     and #0F                                       ; 4 bits menos significativos de esa posicin de memoria
     add a, 'A'                                    ; Ms el carcter 'A' ('A' = 0)
     ld (ix + 1), a

     ld a, (hl)                                    ; PRIMER CARACTER
     and #F0                                       ; 4 bits ms significativos de esa posicin de memoria
     srl a
     srl a
     srl a
     srl a
     add a, 'A'                                    ; Ms el carcter 'A' ('A' = 0)
     ld (ix + 0), a


     inc hl                                        ; Nos vamos al segundo dato del nivel

     ld a, (hl)                                    ; SEXTO CARACTER
     and #0F                                       ; 4 bits menos significativos del dato correspondiente
     add a, 'A'                                    ; Ms el carcter 'A' ('A' = 0)
     ld (ix + 5), a

     ld a, (hl)                                    ; QUINTO CARACTER
     and #F0                                       ; 4 bits ms significativos del dato correspondiente
     srl a
     srl a
     srl a
     srl a
     add a, 'A'                                    ; Ms el carcter 'A' ('A' = 0)
     ld (ix + 4), a

     call ED_DESACTIVABANK

     ld bc, #1109                                  ; Imprimimos en esta posicin
     ld hl, STR_PWD                                ; La contrasea que acabamos de generar
     call PRINTSTR

;     call WAITFORNOKEY
     ld hl, STR_PRESSTOSTART                       ; Imprimimos el "Press to start"
     ld bc, #1705
     call PRINTSTR


     ld ix, MINUTOSMAX
     ld (ix + 0), 29                               ; 29 minutos para acabar el nivel
     ld (ix + 1), 2                                ; Inicializamos el Tiempo a restar a 2 min.
     ld (ix + 2), #ff                              ; Tiempo cartel: Lo ponemos a #ff para que no lo borre al principio

     ld hl, HURRYACTIVE
     ld (hl), 0

     ld hl, ESTADOTABLERO                          ; Vamos a llenar la tabla de estado del tablero con 0's
     ld (hl), 0
     ld de, ESTADOTABLERO+1
     ld bc, 255
     ldir                                          ; A llenar!!!!!!!!

     call CUENTABLANCOS                            ; Vamos ahora a contar las casillas "blancas" del nivel actual

     ld a, #10
     ld (PUEDEDISPARAR), a

     xor a
     ld (VAR3), a

     in a, (#FE)
     cpl
     and #1f
     ld b, a

     INITL_WFK:

     halt

     xor a
     in a, (#FE)
     cpl
     and #1f
     jp nz, INITL_WFK2
     ld b, a

     call JOYSTICK_TRIGGER
     ld a, (JOYSTICK)
     and a
     jp nz, INITL_WFK_EXIT

     INITL_WFK2:

     push bc

     call INTERLEVEL_SCROLL

     ld hl, VAR3
     inc (hl)
     ld a, (hl)
     cp 2
     jp nz, SALGUINO
     ld (hl), 0

     ld hl, GUINO_Act
     ld e, (hl)
     ld d, 0

     ld hl, GUINO_Anim
     add hl, de
     add hl, de

     ld e, (hl)
     inc hl
     ld d, (hl)

     ex de, hl

     ld bc, #0608
     ld de, #0304
     call DRAWGFX

     ld hl, GUINO_Act
     inc (hl)
     ld e, (hl)
     ld a, (GUINO_Ret)
     cp e
     jp nz, SALGUINO

     ld (hl), 0

     SALGUINO:


     ld hl, 23264 - 0 * 32
     ld de, COLORCITOS + 32
     ld bc, 32
     call SCRCOLORCITOS

     pop bc

     xor a
     in a, (#FE)
     cpl
     and #1f
     xor b
     jr z, INITL_WFK

     INITL_WFK_EXIT:
     
     call ESPIRAL

     xor a
     ld (PUEDEDISPARAR), a

     ld hl, GFX_MARCO
     call DEPACK_SCR

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ffff
     ld (ATTR_ACT), de

     ld de, (SCORE)
     ld bc, #111d
     call PRINTNUM

     ld de, (HISCORE)
     ld bc, #141d
     call PRINTNUM

     ld bc, #091A
     ld hl, LEVELACT
     ld e, (hl)
     ld d, 0
     call PRINTNUM


     ld bc, #091D
     ld hl, SUBNIVELES+1
     ld e, (hl)
     ld d, 0
     call PRINTNUM

     call SHOWALLNUMBERS

     call RESETCLOCK                                ; Pon a 0 el reloj

;     ld bc, $0f0f

;     INITL_CHECKENDED1:

;     ld a, $ff
;     ld (VAR3), a
;     ld e, COLOR_MARCA
;     ld d, #ff
;     ld (ATTR_ACT), de
;     push bc
;     call AUTOMARK
;     pop bc

;     dec b
;     jp p, INITL_CHECKENDED1

;     ld b, 0

;     INITL_CHECKENDED2:

;     ld a, $ff
;     ld (VAR3), a
;     ld e, COLOR_MARCA
;     ld d, #ff
;     ld (ATTR_ACT), de
;     push bc
;     call AUTOMARK
;     pop bc

;     dec c
;     jp p, INITL_CHECKENDED2


     ld hl, $0707
     ld (COORDENADAS), hl

     ld bc, #0010
     ld e, PAPER_YELLOW | INK_BLACK
     call DIBUJAPEQUE

     ld d, PAPER_YELLOW                             ; Pinta de amarillo el selector
     ld e, 0
     ld bc, #ffff                                   ; Para que pinte los dos "lados" del cursor: La fila y la columna
     call DRAWSELECTOR
     call RESETMODOCURSOR


     ld hl, SETUP                                   ; Reactiva el loop en la musica
     ld (hl),0

     call MUTE
     call START_INGAMEMUSIC

     ret

START_INGAMEMUSIC:

     ld hl, LEVELACT
     ld a, (hl)

     ld hl, MUS_INGAME
     bit 0, a
     jp z, START_IGMUS_01

     ld hl, MUS_INGAME2

     START_IGMUS_01:

     call START
     ret

DIBUJAPEQUE:
     ld (VAR3), bc

     ld d, #ff
     ld (ATTR_ACT), de

     ld de, LEVEL_DATA + 1

     ld a, (SUBNIVELACT)                           ; Si vamos por el primer "subnivel"
     and a
     ret z                                          ; Vulvete ya

     call DPEQ_DrawSquare

     DPEQUE1:
     ld de, LEVEL_DATA + 1

     DPEQUE2:
     ld a, (ATTR_ACT)
     or BRIGHT
     ld (ATTR_ACT), a

     ld bc, (VAR3)

     ld a, (SUBNIVELES)
     cp 1
     call z, DP_1
     ld a, (SUBNIVELES)
     cp 4
     call z, DP_4

     ld (VAR3), bc

     xor a               ; Ponemos a 0 el Acumulador

     DP_Bucle:

     push af

     call DPEQ_Draw

     pop af
     inc a

     ld hl, SUBNIVELACT
     cp (hl)                 ; Hemos llegado al ltimo???? (por el que vamos)
     ret nc                   ; Pues te vuelves

     push af

     ld a, (SUBNIVELES)
     cp 4
     jp z, DP_S4

     pop af
     cp 3
     jp z, DP_SigFil
     cp 6
     jp z, DP_SigFil

     jp DP_SigCol


     DP_S4:
     pop af
     cp 2
     jp z, DP_SigFil

     jp DP_SigCol

DP_1:
     inc b
     inc c
DP_4:
     inc b
     inc c
     ret

DP_SigCol:
     inc c
     dec b
     jp DP_Bucle

DP_SigFil:

     inc b
     push af
     ld a, (VAR3)
     ld c, a
     pop af

     jp DP_Bucle

DPEQ_DrawSquare:
     ld bc, (VAR3)
DPEQ_DrawSquare1:
     ld hl, STR_LINEAENBLANCO + 26
     call PRINTSTR
     ld a, (VAR3)
     ld c, a
     inc b
     ld a, (VAR3+1)
     add a, 6
     cp b
     jp nz, DPEQ_DrawSquare1
     ret


DPEQ_Draw:
     call PRINT
     inc c
     call PRINT
     dec c
     inc b
     call PRINT
     inc c
     call PRINT
     ret







INITL_SumaBlanco:
     ld hl, BLANCOSNIVEL                            ; Suma uno en (BLANCOSNIVEL)
     inc (hl)
     ret

; GETPUNTERONIVEL: Apunta HL al inicio de los datos del nmero de nivel indicado en A. Adems, usa DE.

GETPUNTERONIVEL:
     ld d, 0            ; Primero vamos a extraer el puntero hacia el nivel de la tabla de punteros
     ld e, a
     ld hl, $c000
     add hl, de
     add hl, de                           ; Ahora tenemos HL apuntando al puntero del dibujo actual

     ld e, (hl)                                    ; Y lo pasamos a DE
     inc hl
     ld d, (hl)                                    ; Ahora tenemos en DE el puntero al grfico

     ex de, hl

     ret


; Vuelca en LEVEL_DATA el nivel nmero A
DUMPLEVEL
     call GETPUNTERONIVEL

     ld de, LEVEL_DATA
     ld bc, 289
     ldir

     ret


CALCULAPUNTERO_NUEVONIVEL:
     di
     ld a, (SETTYPE)                               ; Cogemos el nivel del banco que sea, en funcin de si es el juego "original" o el "customizado"
     ld b, a
     call SETRAMBANK

     ld a, (LEVELACT)
     call DUMPLEVEL

     ld b,0
     call SETRAMBANK
     ei

     ld a, (LEVEL_DATA)                            ; Cogemos el nmero de subniveles
     ld de, LEVEL_DATA + 1                         ; El primer dato es el nmero de "subniveles"

     ld (DIBUJOACTUAL), de                         ; Para meterlo en la variable DIBUJOACTUAL

     ld hl, SUBNIVELES                             ; Metemos en SUBNIVELES el nmero de sub-niveles :P
     ld (hl), a                                    ; que tenamos metido en A
     inc hl
     ld (hl), 0

     xor a                                         ; Activamos el flag ZERO

     ret

CALCULAPUNTERO_SUBNIVEL:

     ld hl, DIBUJOACTUAL                           ; El puntero que hay ahora lo desplazamos 32 bytes hacia "adelante": 8 bytes * 4 caracteres
     ld e, (hl)                                    ; Primero metemos el contenido de la variable (el puntero en s)
     inc hl                                        ; en el registro DE
     ld d, (hl)

     ld hl, 32                                     ; Vamos a sumarle estos 32 bytes

     add hl, de
     ex de, hl                                     ; Y metemos el resultado en DE

     ld hl, DIBUJOACTUAL                           ; Para meterlo en la variable DIBUJOACTUAL
     ld (hl), e
     inc hl
     ld (hl), d

     ret

; MUEVESELECTOR: Mueve el selector a donde sea necesario
; ENTRADA: BC: Desplazamiento horizontal y vertical
; Utiliza DE, HL, AF y mantiene BC

MUEVESELECTOR:

     ld a,b                                        ; Si BC = 0, nos volvemos, porque no hay que moverse
     or c
     ret z

     push bc                                       ; Nos guardamos BC, que CNUMBERS se lo carga

     call MINI_CNUMBERS                                 ; Vamos, primero, a borrar el selector actual: Primero la parte de fuera

     pop bc

     ld d, PAPER_RED                               ; Y ahora dentro del tablero
     ld e, 8                                       ; Desde la fila 8 (Dentro del tablero)


     push bc

     call DELETESELECTOR

;;     call DRAWSELECTOR                             ; Y a pintar, es decir, borrarlo

     pop bc                                        ; Recuperamos nuestro BC

     ld hl, COORDENADAS                            ; Aplicamos el desplazamiento: Primero a las columnas
     ld a, (hl)
     add a, c
     ld (hl), a

     inc hl                                        ; Y luego a las filas
     ld a, (hl)
     add a, b
     ld (hl), a

     ld hl, PUEDEDISPARAR                          ; Como nos hemos movido, ya podemos volver a "disparar"
     ld (hl), 1


     ld bc,#ffff                                   ; Para pintar las dos partes de la cruceta

     ld d, PAPER_YELLOW                            ; Y volvemos a pintar el selector nuevo
     ld e, 0                                       ; Desde la fila 0 (Desde dentro del tablero)

     call RETMODOCURSOR                            ; Vamos a ver si estamos en modo "HINT"
     cp HINTMODE                                   ; Si no es as,
     jp nz, DRAWSELECTOR                           ; Dibujamos ya (hace un JP, luego el RET de esa rutina volver a donde se ha llamado a sta)

     ld d, PAPER_MAGENTA                            ; Y volvemos a pintar el selector nuevo
     call DRAWSELECTOR


     ret                                           ; et voil!

SUBE:
     ld hl, COORDENADAS+1
     ld a, (hl)
     and a
     ret z
     dec d
     scf
     ret

BAJA:
     ld hl, COORDENADAS+1
     ld a, (hl)
     cp 15
     ret z
     inc d
     scf
     ret

IZQUIERDA:
     ld hl, COORDENADAS
     ld a, (hl)
     and a
     ret z
     dec e
     scf
     ret

DERECHA:
     ld hl, COORDENADAS
     ld a, (hl)
     cp 15
     ret z
     inc e
     scf
     ret

FUEGO:
     ld d, 0
     call DRAWCURSOR

     ld e, d
     ld d, #3F
     ld (ATTR_ACT), de

     ld bc, (COORDENADAS)

     call RETMODOCURSOR
     cp ABRE
     jp z, FUEGO_Abre
     cp CIERRA
     jp z, FUEGO_Cierra
     cp HINTMODE
     jp z, FUEGO_Hint



     call RETSTATUS
     cp BLANCO
     jp z, FUEGO_Cierra


FUEGO_Abre:
     ld a, ABRE
     call SETMODOCURSOR

     call RETBIT
     jp c, FUEGO_Marca

     call RETSTATUS
     cp BLANCO
     ret z

     ld a, 3
     call INICIA_EFECTO

     ld a, BLANCO
     call SETSTATUS
     call DRAWSQUARE

     ld hl, BLANCOSNIVEL
     dec (hl)

     ld e, PAPER_YELLOW
     ld d, #ff
     ld (ATTR_ACT), de

     xor a
     ld (VAR3), a

     call AUTOMARK

     and a

     ret

FUEGO_Marca:
     ld a, (PUEDEDISPARAR)
     and a
     ret z

     ld a, 6
     call INICIA_EFECTO

     ld hl, PUEDEDISPARAR
     ld (hl), 0

     ld a, MARCA
     call SETSTATUS
     call DRAWSQUARE

     ld hl, TIEMPOARESTAR
     ld d, 0
     ld e, (hl)
     inc (hl)

     call RESTATIEMPO
     ret

FUEGO_Cierra:

; Este es el que serva para que se pudieran cerrar casillas ya abiertas previamente.
; Est comentado porque, durante el desarrollo de la versin CPC, llegamos a la conclusin
; de que no tena mucho sentido permitir esta opcin al jugador... as que haba que quitarlo.
; En lugar de buscar otra solucin ms elegante (mandando retornar en lugar de venir aqu),
; lo dejo as para "no perder" este cdigo, por si ms adelante nos da por volver a cambiarlo.

;     call RETSTATUS
;     cp CERRADO
;     ret z

;     ld a, 1
;     call INICIA_EFECTO

;     call RETSTATUS
;     cp BLANCO
;     jr nz, FUEGO_CierraMarca

;     ld hl, BLANCOSNIVEL
;     inc (hl)

;     FUEGO_CierraMarca:

;     ld a, CIERRA
;     call SETMODOCURSOR

;     ld a, CERRADO
;     call SETSTATUS
;     call DRAWSQUARE

     ret

FUEGO_Hint:
     push bc

     ld b, #0f

     FUEGOH_BucleFila:

     call RETSTATUS
     cp BLANCO
     call nz, FUEGOH_DecBlancosNivel

     ld a, $ff
     ld (VAR3), a

     call RETBIT
     ld a, BLANCO
     call c, FUEGOH_Marca
     call SETSTATUS
     call DRAWSQUARE
     push bc
     ld e, COLOR_MARCA
     ld d, #ff
     ld (ATTR_ACT), de
     call AUTOMARK
     pop bc
     dec b
     jp p, FUEGOH_BucleFila

     pop bc

     ld c, #0f

     FUEGOH_BucleColumna:

     call RETSTATUS
     cp BLANCO
     call nz, FUEGOH_DecBlancosNivel

     call RETBIT
     ld a, BLANCO
     call c, FUEGOH_Marca
     call SETSTATUS
     call DRAWSQUARE
     push bc
     call AUTOMARK
     pop bc
     dec c
     jp p, FUEGOH_BucleColumna

     call HINT

     ld d, 0
     ld e, 5
     call RESTATIEMPO

     ld hl, PUEDEDISPARAR
     ld (hl), 0

     ret


     FUEGOH_Marca:
     ld a, MARCA
     ret

     FUEGOH_DecBlancosNivel:
     call RETBIT
     ret c
     ld hl, BLANCOSNIVEL
     dec (hl)
     ret



; AUTOMARK: Chequea si la columna y la fila apuntadas en BC tienen todas las blancas descubiertas, y, si lo
; estn, marca las cerradas como MARCA

AUTOMARK:
     push bc
     call CHECKCOLENDED
     pop bc

     jp nz, AUTOMARK_Fila

     call AUTOMARK_CNUMBERS

     push bc

     ld b, $0f

     AUTOMARK_MarkBucle1:

     call RETSTATUS
     cp CERRADO
     jp nz, AUTOMARK_MarkBucle1_Next

     ld a, MARCA
     call SETSTATUS
     call DRAWSQUARE

     AUTOMARK_MarkBucle1_Next:

     dec b
     jp p, AUTOMARK_MarkBucle1

     pop bc

     AUTOMARK_Fila:

     push bc
     call CHECKFILAENDED
     pop bc

     ret nz

     call AUTOMARK_CNUMBERS

     ld c, $0f

     AUTOMARK_MarkBucle2:

     call RETSTATUS
     cp CERRADO
     jp nz, AUTOMARK_MarkBucle2_Next

     ld a, MARCA
     call SETSTATUS
     call DRAWSQUARE

     AUTOMARK_MarkBucle2_Next:

     dec c
     jp p, AUTOMARK_MarkBucle2

     ret

AUTOMARK_CNUMBERS:
     ld a, (VAR3)
     and a
     ret z

     push bc
     ld de, (COORDENADAS)
     push de
     ld de, (ATTR_ACT)
     push de

     ld (COORDENADAS), bc

     ld bc, $ffff

     call MINI_CNUMBERS

     pop de
     ld (ATTR_ACT), de
     pop de
     ld (COORDENADAS), de
     pop bc
     ret



; CHECKCOLENDED: Chequea si la columna apuntada por el registro C ha sido descubierta del todo o no
; Entrada: C Columna
; Salida: Z activado si la columna est terminada NZ si no lo est


CHECKCOLENDED:

     ld b, 15

     ld a, $ff
     ld (VAR3), a

     CHECKCEND_Bucle1:

     call RETBIT

     jp c, CHECKCEND_Bucle1_Next                     ; Si el bit es 1, sltate al siguiente pxel del dibujo
     
     xor a
     ld (VAR3), a

     call RETSTATUS

     cp BLANCO

     ret nz                                          ; Si es BLANCO y no est "abierto", vulvete, porque la columna no est terminada

     CHECKCEND_Bucle1_Next:

     dec b
     jp p, CHECKCEND_Bucle1

     ld a, (VAR3)
     and a
     ret nz

     xor a                                           ; Activamos el flag 0, ya que antes nos volvimos con la cond NZ

     ret


; CHECKFILAENDED: Chequea si la fila apuntada por el registro B ha sido descubierta del todo o no
; Entrada: B Fila
; Salida: Z activado si la columna est terminada NZ si no lo est


CHECKFILAENDED:

     ld c, 15

     ld a, $ff
     ld (VAR3), a

     CHECKFEND_Bucle1:

     call RETBIT

     jp c, CHECKFEND_Bucle1_Next                     ; Si el bit es 1, sltate al siguiente pxel del dibujo

     xor a
     ld (VAR3), a

     call RETSTATUS

     cp BLANCO

     ret nz                                          ; Si es BLANCO y no est "abierto", vulvete, porque la fila no est terminada

     CHECKFEND_Bucle1_Next:

     dec c
     jp p, CHECKFEND_Bucle1

     ld a, (VAR3)
     and a
     ret nz

     xor a                                           ; Activamos el flag 0, ya que antes nos volvimos con la cond NZ

     ret


MARK:
     ld d, 0
     call DRAWCURSOR

     ld e, d
     ld d, #00
     ld (ATTR_ACT), de

     ld bc, (COORDENADAS)

     call RETMODOCURSOR
     cp MARCA
     jp z, MARK_Marcar
     cp DESMARCA
     jp z, MARK_Cerrar



     call RETSTATUS
     cp MARCA
     jp z, MARK_Cerrar

;     jp MARK_Marcar


MARK_Marcar:
     call RETSTATUS
     cp BLANCO
     ret z

     cp MARCA
     ret z

     ld a, 5
     call INICIA_EFECTO

     ld a, MARCA
     call SETMODOCURSOR
     call SETSTATUS
     call DRAWSQUARE
     ret
MARK_Cerrar:
     ld a, DESMARCA
     call SETMODOCURSOR
     call RETSTATUS
     cp BLANCO
     ret z

     cp CERRADO
     ret z

     ld a, 4
     call INICIA_EFECTO

     ld a, CERRADO
     call SETSTATUS
     call DRAWSQUARE
     ret

; Como el PAUSE de Basic, con B 1/50 de segs.
PAUSE:
;      xor a
;      in a, (#FE)
;      cpl
;      and #1f
;      ret nz

;      djnz PAUSE
;      ret
     ld a, b
     and a
     ret z

     xor a
     in a, (#FE)
     cpl
     and #1f
     ld c, a

     PAUSE1:

     xor a
     in a, (#FE)
     cpl
     and #1f
     jp nz, PAUSE2
     ld c, a

     PAUSE2:

     xor a
     in a, (#FE)
     cpl
     and #1f
     xor c
     ret nz

     halt

     djnz PAUSE1

     ret


; Como el PAUSE, pero no se anula al pulsar tecla
WAIT:
      halt
      djnz WAIT
      ret

IMPRIMETIEMPO:

     call BORRACARTEL

     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de


     ld a, (SEGUNDOS)
     cp 50
     jp nz, PRTIME_NZSeg

     ld a, '0'
     ld bc, #0C1C
     call PRINTCHR

     PRTIME_NZSeg:

     ld d, 0

     ld hl, SEGUNDOS
     ld e, (hl)
     ld a, 59
     sub e
     ld e, a
     ld bc, #0C1D
     call PRINTNUM

     ld bc, #0C1B
     ld e, ':'

     ld hl, TICKS
     ld a, (hl)
     cp 25
     ld a, e
     jr c, IMPRIME_Minutos

     ld a, ' '

     IMPRIME_Minutos:

     call PRINTCHR


     ld a, (MINUTOSMAX)
     ld hl, MINUTOS
     ld e, (hl)
     sub e
     cp 10
     jp nc, PRTIME_NZMin


     ld a, '0'
     ld bc, #0C19
     call PRINTCHR

     PRTIME_NZMin:

     ld d, 0

     ld a, (MINUTOSMAX)
     ld hl, MINUTOS
     ld e, (hl)
     sub e
     ret c           ; Si te pasas de 0, no imprimas nada
     jp z, HURRYUP
     ld e, a
     ld bc, #0C1A
     call PRINTNUM

     ret

HURRYUP:
     ld a, (HURRYACTIVE)
     and a
     ret nz

     ld de, 0
     ld bc, #0C1A
     call PRINTNUM

     ld hl, HURRYACTIVE
     ld (hl), #ff

     call MUTE
     ld hl, MUS_HURRYUP
     call START

     ret

BORRACARTEL:
     ld hl, TIEMPOCARTEL
     ld a, (hl)

     cp #ff
     ret z

     ex de, hl

     ld hl, SEGUNDOS
     ld b, (hl)
     cp b
     ret nz

     ex de, hl

     ld (hl), #ff

     ld e, PAPER_BLACK | INK_BLACK
     ld d, #ff
     ld (ATTR_ACT), de


     ld bc, #0D19
     ld hl, STR_LINEAENBLANCO + 27
     call PRINTSTR

     ret

;Resta el tiempo que corresponda del total disponible
RESTATIEMPO:
    push de

    ld hl, MINUTOS
    ld a, (hl)
    add a, e
    ld (hl), a

    ld hl, SEGUNDOS
    ld a, (hl)
    add a, 3

    cp 59
    jr c, RESTAT_Impr

    sub 59

    RESTAT_Impr:

    ld hl, TIEMPOCARTEL
    ld (hl), a

    ld e, PAPER_RED | INK_WHITE | BRIGHT | FLASH
    ld d, #ff
    ld (ATTR_ACT), de

    ld bc, #0D19
    ld hl, STR_TIEMPO0
    call PRINTSTR

    pop de
    ld bc, #0D1A
    call PRINTNUM

    ret



CHECKTIMEOVER:

     ld hl, MINUTOSMAX
     ld a, (hl)
     inc a
     ld hl, MINUTOS
     ld e, (hl)
     cp e
     jp c, TIMEOVER
     ret nz

     TIMEOVER:


     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #0C19
     ld hl, STR_TIEMPO0
     call PRINTSTR

     ld e, PAPER_RED | INK_WHITE | BRIGHT | FLASH
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #0D19
     ld hl, STR_GAMEOVER1
     call PRINTSTR
     ld bc, #0E19
     ld hl, STR_GAMEOVER2
     call PRINTSTR
     ld bc, #0F19
     ld hl, STR_GAMEOVER3
     call PRINTSTR

     call MUTE
     ld hl, MUS_DEAD
     call START

     ld b, 170
     call WAIT

     ld hl, GFX_GAMEOVER
     call DEPACK_SCR

     call MUTE

     ld hl, MUS_THEEND
     call START

     ld b, 200
     xor a
     ld (VAR3), a

     LLORO:

     push bc

     halt

     ld hl, VAR3
     inc (hl)
     ld a, (hl)
     cp 4
     jp nz, SALLLORO
     ld (hl), 0

     ld hl, LLORO_Act
     ld e, (hl)
     ld d, 0

     ld hl, LLORO_Anim
     add hl, de
     add hl, de

     ld e, (hl)
     inc hl
     ld d, (hl)

     ex de, hl

     ld bc, #090d
     ld de, #0603
     call DRAWGFX

     ld hl, LLORO_Act
     inc (hl)
     ld e, (hl)
     ld a, (LLORO_Ret)
     cp e
     jp nz, SALLLORO

     ld (hl), 0

     SALLLORO:

     pop bc

     djnz LLORO


     call FADE_OUT

     scf
     ret


CHECKLEVELOVER:

     ld hl, BLANCOSNIVEL
     ld a, (hl)
     and a

     ret nz

     call VIEW

     ld e, PAPER_BLUE | INK_YELLOW | BRIGHT | FLASH
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #0D19
     ld hl, STR_LEVELOVER1
     call PRINTSTR
     ld bc, #0E19
     ld hl, STR_LEVELOVER2
     call PRINTSTR
     ld bc, #0F19
     ld hl, STR_LEVELOVER3
     call PRINTSTR


     ld hl, SUBNIVELES
     ld a, (hl)

     inc hl
     inc (hl)
     ld b, (hl)

     cp b
     jp nz, CHECKLO_NoNuevoNivel

     ld hl, LEVELACT                               ; Y apuntamos con HL al LEVELACT (Nivel actual)...
     inc (hl)                                      ; NUEVO NIVEL

     CHECKLO_NoNuevoNivel:


     ld bc, #0010
     ld e, PAPER_YELLOW | INK_BLACK
     call DIBUJAPEQUE

     call MUTE
     ld hl, MUS_WIN
     call START

     call LEVELOVER_AbejaStop

     ld b, 125
     call WAIT

     call MUTE

     call SUMAPUNTOS

     call LEVELOVER_AbejaStop

     ld b, 150
     call PAUSE

     call ESPIRAL

     call INITLEVEL
     pop af                          ; Hemos venido con un call, hay que restaurar la pila
     jp CICLOJUEGO


SUMAPUNTOS:
     ld e, PAPER_BLACK | INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #1218
     ld a, '+'
     call PRINTCHR
     ld bc, #1219
     ld hl, STR_LINEAENBLANCO + 27
     call PRINTSTR

     ld hl, 0
     ld (BONUS), hl

     ld bc, (SEGUNDOS)

     ld a, 60

     sub c
     SUMAP_BucleSeg:

     ld hl, BONUS
     inc (hl)

     halt
     halt

     dec a

     ld (VARa3), a

     ld de, (BONUS)
     ld bc, #121d
     call PRINTNUM

     ld a, (VARa3)

     cp 10
     jr nc, SP_Salta0Seg

     ld bc, #0c1c
     ld de, 0
     call PRINTNUM

     ld a, (VARa3)


     SP_Salta0Seg:


     ld bc, #0c1d
     ld e, a
     call PRINTNUM


     ld a, 0
     call INICIA_EFECTO

     ld a, (VARa3)

     ld de, SP_Seg_DespuesAnim
     push de

     bit 2, a
     jp z, LEVELOVER_Abejita1
     jp LEVELOVER_Abejita2

     SP_Seg_DespuesAnim:

     ld a, (VARa3)
     and a

     jr nz, SUMAP_BucleSeg





     ld bc, (SEGUNDOS)

     ld a, 29
     sub b
     ret z
     SUMAP_BucleMin:

     ld hl, (BONUS)
     ld de, 60
     adc hl, de
     ld (BONUS), hl

     halt
     halt

     dec a

     ld (VARa3), a

     ld de, (BONUS)
     ld bc, #121d
     call PRINTNUM

     ld a, (VARa3)

     cp 10
     jr nc, SM_Salta0Min


     ld bc, #0c19
     ld de, 0
     call PRINTNUM

     ld a, (VARa3)

     SM_Salta0Min:

     ld bc, #0c1a
     ld e, a
     call PRINTNUM


     ld a, 0
     call INICIA_EFECTO

     ld a, (VARa3)

     ld de, SP_Min_DespuesAnim
     push de

     bit 2, a
     jp z, LEVELOVER_Abejita1
     jp LEVELOVER_Abejita2

     SP_Min_DespuesAnim:

     ld a, (VARa3)
     and a

     jr nz, SUMAP_BucleMin

     ld b, 25
     call WAIT

     ld hl, (BONUS)
     ld de, (SCORE)
     add hl, de
     ex de, hl
     ld (SCORE), de

     ld bc, #111d
     call PRINTNUM

     ld bc, #1218
     ld hl, STR_LINEAENBLANCO + 26
     call PRINTSTR

     ld hl, (SCORE)
     ld de, (HISCORE)
     and a
     sbc hl, de
     call nc, ADJUSTHISCORE

     ld a, 0
     call INICIA_EFECTO

     ld b, 25
     call WAIT

     ret

LEVELOVER_AbejaStop:

     ld e, INK_YELLOW
     ld d, #ff
     ld (ATTR_ACT), de

     ld de, ABEJA_MARCADOR0
     ld bc, #0217
     call PRINT

     push de
     ld e, INK_YELLOW | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de
     pop de
     inc c
     call PRINT
     inc c
     call PRINT

     push de
     ld e, INK_YELLOW
     ld d, #ff
     ld (ATTR_ACT), de
     pop de
     ld bc, #0317
     call PRINT

     push de
     ld e, INK_YELLOW | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de
     pop de
     inc c
     call PRINT
     inc c
     call PRINT

     push de
     ld e, INK_YELLOW
     ld d, #ff
     ld (ATTR_ACT), de
     pop de
     ld bc, #0417
     call PRINT
     inc c
     call PRINT
     inc c
     call PRINT

     ret


LEVELOVER_Abejita1:

     ld de, 0
     ld (ATTR_ACT), de

     ld de, ABEJA_MARCADOR1
     ld bc, #0217
     call PRINT
     inc c
     call PRINT
     inc c
     call PRINT
     ld bc, #0317
     call PRINT
     inc c
     call PRINT
     inc c
     call PRINT
     ld bc, #0417
     call PRINT
     inc c
     call PRINT
     inc c
     call PRINT

     ret


LEVELOVER_Abejita2:

     ld de, 0
     ld (ATTR_ACT), de

     ld de, ABEJA_MARCADOR2
     ld bc, #0217
     call PRINT
     inc c
     call PRINT
     inc c
     call PRINT
     ld bc, #0317
     call PRINT
     inc c
     call PRINT
     inc c
     call PRINT
     ld bc, #0417
     call PRINT
     inc c
     call PRINT
     inc c
     call PRINT

     ret

ADJUSTHISCORE:
     ld de, (SCORE)
     ld (HISCORE), de

     ld bc, #141d
     call PRINTNUM

     ret

RETMODOCURSOR:
     ld hl, MODOCURSOR
     ld a, (hl)
     ret

SETMODOCURSOR:
     ld hl, MODOCURSOR
     ld (hl),a
     ret

RESETMODOCURSOR:
     ld hl, MODOCURSOR
     ld (hl), 0
     ld d, 0
     call DRAWCURSOR
     ret

NOFUEGO:
     ld hl, PUEDEDISPARAR
     ld (hl), 1
     call RETMODOCURSOR
     cp HINTMODE
     ret z
     cp ABRE
     call z, RESETMODOCURSOR
     cp CIERRA
     call z, RESETMODOCURSOR
     ret

NOMARK:
     call RETMODOCURSOR
     cp HINTMODE
     ret z
     cp MARCA
     call z, RESETMODOCURSOR
     cp DESMARCA
     call z, RESETMODOCURSOR
     ret

CHECKHINT:
     ld hl, CONTROLS + 6
     ld a, (hl)
     call KTEST1
     call nc, HINT
     call c, RESETHINTTRIGGER
     ret

RESETHINTTRIGGER:
     ld hl, HINTTRIGGER
     ld (hl), 0
     ret

HINT:
     ld hl, HINTTRIGGER
     ld a, (hl)
     and a
     ret nz

     ld (hl), #ff

     ld a, 2
     call INICIA_EFECTO

     call RETMODOCURSOR
     cp HINTMODE
     jp z, QUITAHINT
     ld a, HINTMODE
     call SETMODOCURSOR
     ld d, PAPER_MAGENTA
     ld e, 0
     ld bc, #ffff
     call DRAWSELECTOR
     ret
QUITAHINT:
     call RESETMODOCURSOR
     ld bc,#ffff                                   ; Para pintar las dos partes de la cruceta
     ld d, PAPER_YELLOW                            ; Y volvemos a pintar el selector nuevo
     ld e, 0                                       ; Desde la fila 0 (Desde dentro del tablero)
     call DRAWSELECTOR
     ret

PAUSA:

     call SAVE_SCR

     ld de, (SEGUNDOS)
     ld (VAR3), de

     ld de,#0000
     ld bc,#ffff
     call DELETESELECTOR

     ld bc, #00ff
     ld de, #0810

     PAUSA_B1:

     inc c

     call DF_LOCATE


     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0

     dec e
     jr nz, PAUSA_B1

     inc b
     ld c, #ff

     ld e, #10

     dec d
     jr nz, PAUSA_B1


     ld bc, #080f
     ld de, #1008

     PAUSA_B2:

     inc c

     call DF_LOCATE


     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0
     inc h
     ld (hl),0

     dec e
     jr nz, PAUSA_B2

     inc b
     ld c, #0f

     ld e, #08

     dec d
     jr nz, PAUSA_B2

     ld de, #00ff
     ld (CONT_SCR_MENU), de
     ld de, #00ff
     ld (CONT_SCR_PAUSE), de


     ld hl, STR_PAUSA
     ld a, (hl)
     ld hl, BUFSCRPAUSE
     push hl
     call IMPR_NCHAR1_Pausa
     pop hl ; Para restaurar la pila

     ld hl, CONT_SCR_MENU
     ld a, -16
     ld (hl), a

     ld hl, -1
     ld (CONT_SCR_MENU + 1), hl

     ld hl, BUFCREDITS
     ld a, 0
     ld (hl), a
     ld de, BUFCREDITS + 1
     ld bc, 7
     ldir

     call TRAMADO_PAUSA

     ld hl, ZUMO
     ld bc, #0900
     ld de, #100d
     call DRAWGFX

     ld hl, STR_VIN_PAUSA1
     ld bc, #0a04
     ld a, 8
     call PRINTSTR_6X8

     ld hl, STR_VIN_PAUSA2
     ld bc, #0b04
     ld a, 8
     call PRINTSTR_6X8

     call WAITFORNOKEY

     PAUSA_WaitFK:

     call PAUSA_SCR

     xor a
     in a, (#FE)
     cpl
     and #1f
     jr z, PAUSA_WaitFK

     call WAITFORNOKEY

     halt

     call LOAD_SCR

     ld de, (VAR3)
     ld (SEGUNDOS), de

     ld hl, TICKS
     ld (hl),0

     ret

PAUSA_SCR:

     ld hl, CONT_SCR_MENU
     inc (hl)
     ld a, (hl)
     cp 8

     ld hl, BUFCREDITS
     push hl
     ld hl, CONT_SCR_MENU
     call z, IMPR_NCHAR0_Pausa
     pop hl ; Para restaurar la pila

     ld hl, CONT_SCR_PAUSE
     inc (hl)
     ld a, (hl)
     cp 8

     ld hl, BUFSCRPAUSE
     push hl
     ld hl, CONT_SCR_PAUSE
     call z, IMPR_NCHAR0_Pausa
     pop hl ; Para restaurar la pila

     ld b, 8

     ld hl, 22528 + 1
     ld de, 22528

     halt
     halt

     PAUSASCR_B0:
     push bc

     ld bc, 15
     ldir

     pop bc

     ld a, l
     add a, 17
     ld l, a

     ld a, e
     add a, 17
     ld e, a

     djnz PAUSASCR_B0

     ld hl, BUFCREDITS
     ld de, 22528 + 15

     ld b, 8

     PAUSASCR_B1:

     xor a
     rl (hl)
     call c, PAUSA_SCR_Bit1
     ld (de), a

     inc hl

     ld a, e
     add a, 32
     ld e, a

     djnz PAUSASCR_B1

     ld c, 16

     PAUSASCR_B2:
     ld b, 9

     PAUSASCR_B3:
     call ATT_LOCATE

     ld a, (hl)
     ld de, -32
     add hl, de
     ld (hl),a

     inc b
     ld a, b
     cp 24
     jp nz, PAUSASCR_B3

     inc c
     ld a, c
     cp 24
     jp nz, PAUSASCR_B2

     ld hl, BUFSCRPAUSE
     ld de, 23280

     ld b, 8

     ld c, (hl)

     PAUSASCR_B4:

     xor a
     rl c
     call c, PAUSA_SCR_Bit1

     ld (de), a
     inc de

     djnz PAUSASCR_B4

     ld hl, BUFSCRPAUSE + 1
     ld de, BUFSCRPAUSE
     ld bc, 7
     ldir

     ret

PAUSA_SCR_Bit1:
     ld a, PAPER_BLUE | BRIGHT
     ret


IMPR_NCHAR0_Pausa:
;     ld hl, CONT_SCR_MENU
     ld (hl), 0

     inc hl
     ld e, (hl)
     inc hl
     ld d, (hl)

     inc de

     ld (hl), d
     dec hl
     ld (hl), e

     IMPR_NCHAR0P_Hook:

     push hl
     ld hl, STR_PAUSA
     add hl, de
     ld a, (hl)
     pop hl

     and a
     jp nz, IMPR_NCHAR1_Pausa

     ld de, 0
     ld (hl), d
     inc hl
     ld (hl), d
;     ld (CONT_SCR_MENU+1), de

     jp IMPR_NCHAR0P_Hook


IMPR_NCHAR1_Pausa:
      ld h, 0
      ld l, a
      add hl, hl
      add hl, hl
      add hl, hl
      ld de, CHARSET
      dec d
      add hl, de
      ex de, hl


;      ld hl, BUFCREDITS

;  Lo primero que tenemos en la pila, ya que venimos con un CALL, es la direccin de retorno
;  Para acceder al puntero que subimos antes de venir, tenemos que coger Y RESTAURAR ese dato
;  anterior en la pila

      pop bc
      pop hl
      push hl
      push bc

      ld b, 8

      IMPRNCP_Bucle:
      ld a, (de)
      ld (hl), a
      inc hl
      inc de
      djnz IMPRNCP_Bucle

      ret

CONTROLS_KEYB:

     ld hl, JOYSTICK
     ld (hl), 0

     ld hl, CONTROLS
     ld a, (hl)
     call KTEST1
     call nc, JOY_UP

     ld hl, CONTROLS + 1
     ld a, (hl)
     call KTEST1
     call nc, JOY_DOWN

     ld hl, CONTROLS + 2
     ld a, (hl)
     call KTEST1
     call nc, JOY_LEFT

     ld hl, CONTROLS + 3
     ld a, (hl)
     call KTEST1
     call nc, JOY_RIGHT

     ld hl, CONTROLS + 4
     ld a, (hl)
     call KTEST1
     call nc, JOY_FIRE

     ret

CONTROLS_SINC:
     ld hl, JOYSTICK
     ld (hl), 0

     ld a, KEY_9
     call KTEST1
     call nc, JOY_UP

     ld a, KEY_8
     call KTEST1
     call nc, JOY_DOWN

     ld a, KEY_6
     call KTEST1
     call nc, JOY_LEFT

     ld a, KEY_7
     call KTEST1
     call nc, JOY_RIGHT

     ld a, KEY_0
     call KTEST1
     call nc, JOY_FIRE

     ret

CONTROLS_KEMP:
     ld c, #1f
     in b, (c)

     ld hl, JOYSTICK
     ld (hl), b

     ret

JOY_UP:
     ld hl, JOYSTICK
     set 3, (hl)
     ret
JOY_DOWN:
     ld hl, JOYSTICK
     set 2, (hl)
     ret
JOY_RIGHT:
     ld hl, JOYSTICK
     set 0, (hl)
     ret
JOY_LEFT:
     ld hl, JOYSTICK
     set 1, (hl)
     ret
JOY_FIRE:
     ld hl, JOYSTICK
     set 4, (hl)
     ret

READ_JOYSTICK:
     ld hl, READ_JOYSTICK_Return
     push hl
     ld de, (CONTROLPT)
     push de
     ld de, 0
     READ_JOYSTICK_Return:
     ret                      ; jp --> de

SOUNDSWITCH:

     ld hl, TRIGGERSOUND
     ld a, (hl)
     and a
     ret nz

     ld hl, SOUNDSTATUS
     ld a, (hl)
     cpl
     and 1
     ld (hl),a

     call MUTE

     and a
     ret z

     call START_INGAMEMUSIC

     ld hl, TRIGGERSOUND
     ld (hl),1

     ret

SOUNDTRIGGER:
     ld hl, TRIGGERSOUND
     ld (hl),0
     ret


CICLOJUEGO:
;     ld hl, STR_LINEAENBLANCO
;     ld bc, 0
;     call PRINTSTR
;     ld hl, BLANCOSNIVEL
;     ld e, (hl)
;     ld d, 0
;     ld bc, #000a
;     call PRINTNUM

      halt
      halt
      halt
      halt
      halt

     call READ_JOYSTICK
     
     ld a, (JOYSTICK)
     and a
     jp nz, CICLO_JOYNOZERO

     ld a, 3
     ld (STARTKEYREPEAT), a

     CICLO_JOYNOZERO:

     ld a, (JOYTRIGGER)
     ld b, a
     ld a, (JOYSTICK)
     cp b
     jp nz, CICLO_AFTERTRIGGER

     ld a, (STARTKEYREPEAT)
     and a
     jp z, CICLO_AFTERTRIGGER
     dec a
     ld (STARTKEYREPEAT), a
     jp nz, CICLO_AFTERMOVE


     CICLO_AFTERTRIGGER:

     ld a, (JOYSTICK)
     ld (JOYTRIGGER), a

     ld a, (JOYSTICK)
     bit 2, a
     call nz, BAJA

     ld a, (JOYSTICK)
     bit 3, a
     call nz, SUBE

     ld a, (JOYSTICK)
     bit 0, a
     call nz, DERECHA

     ld a, (JOYSTICK)
     bit 1, a
     call nz, IZQUIERDA

     ld b,d
     ld c,e
     call MUEVESELECTOR

     CICLO_AFTERMOVE:

     ld a, (JOYSTICK)
     bit 4, a
     call z, NOFUEGO

     ld a, (JOYSTICK)
     bit 4, a
     call nz, FUEGO

     ld hl, CONTROLS + 5
     ld a, (hl)
     call KTEST1
     call nc, MARK
     call c, NOMARK

     call CHECKHINT

     ld hl, CONTROLS + 7
     ld a, (hl)
     call KTEST1
     call nc, PAUSA
     
     ld hl, CONTROLS + 8
     ld a, (hl)
     call KTEST1
     call c, SOUNDTRIGGER
     call nc, SOUNDSWITCH


     call IMPRIMETIEMPO

;     ld a, KEY_T
;     call KTEST1
;     call nc, TRAMPA

;     ld a, KEY_Y
;     call KTEST1
;     call nc, TRAMPA2

     call CHECKLEVELOVER

     call CHECKTIMEOVER


     jp nc, CICLOJUEGO

     ret

TRAMPA:
     ld hl, BLANCOSNIVEL
     ld (hl), 0
     ret
TRAMPA2:
     pop af
     ret

POSTGAME:
;     call WAITFORNOKEY

     call UNPACK_MENU

     ld de, (SCORE)
     ld hl, HISCORES - 1

     exx             ; Ponemos registros alternativos
     ld bc, #0500    ; B' = Contador: Son 5 Rcords C' = Contador "invertido"

     PG_B0:

     exx             ; Ponemos registros "normales"

     inc hl
     ld c, (hl)
     inc hl
     ld b, (hl)

     call CP16

     jp c, NUEVO_RECORD

     exx             ; POnemos registros alternativos

     inc c           ; Aqu (en C') vamos a llevar el nmero que vamos a ocupar en la tabla
     djnz PG_B0      ; Porque el contador del bucle lo tenemos en B'

     exx             ; Restauramos registros "normales"

     ret

ACTUALIZA_RECORDS:
     ld hl, HISCORE - 3
     ld de, HISCORE - 1
     exx
     ld a, 4
     sub c

     sla a          ; Lo multiplicamos por dos, porque son dos bytes por cada puntuacin

     ld e, a
     ld d, 0

     push de
     exx
     pop bc

     ld a, b
     or c
     jp z, AR_NoLDDR

     lddr                 ; Primero desplazamos los rcords batidos hacia abajo

     AR_NoLDDR:

     inc hl              ; Ahora vamos a "inyectar" el rcord nuevo
     ld de, SCORE

     ld a, (de)
     ld (hl), a
     inc hl
     inc de
     ld a, (de)
     ld (hl), a


     ; Ahora vamos a por los nombres

     ld hl, STR_HISCORE - 9
     ld de, STR_HISCORE - 1

     exx

     ld a, 4
     sub c

     sla a
     sla a
     sla a  ; x8

     ld e, a
     ld d, 0

     push de

     exx

     pop bc

     ld a, b
     or c
     ret z

     lddr

     ret

NUEVO_RECORD:
     call ACTUALIZA_RECORDS

     inc hl
     ld (VAR3), hl

     ld d, h
     ld e, l
     inc e

     ld (hl), ' '
     ld bc, 6
     ldir

     ld bc, #0c09
     ld hl, STR_CONGRAT
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #0f09
     inc hl
     call PRINTSTRX2

     ld e, INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, VAR2                          ; La vamos a usar como contador de caracteres
     ld (hl), 0


     ENTERRECORD_Bucle:

     halt

     call DIBUJA_FLAN

     call KFIND
     cp #ff
     jp z, ENTERRECORD_NoKey

     cp 40
     jp z, ENTERRECORD_Delete

     cp KEY_EN
     ret z

     push hl
     ld hl, PUEDEDISPARAR
     ld a, (hl)
     and a
     pop hl
     jp z, ENTERRECORD_Bucle

     call ENTERRECORD_Key

     jp ENTERRECORD_Bucle

ENTERRECORD_NoKey:
     ld hl, PUEDEDISPARAR
     ld (hl), 1
     jp ENTERRECORD_Bucle

ENTERRECORD_Key:
     push hl

     ld hl, VAR2
     ld a, (hl)
     cp 7

     pop hl

     ret z

     ld a, (hl)

     cp '0'
     ret c

     cp 'Z'+1
     ret nc

     ld hl, VAR2
     ld e, (hl)
;     ld d, 0
     inc (hl)


     ld hl, (VAR3)
     add hl, de
     ld (hl), a

     ld hl, (VAR3)
     ld bc, #140D
     call PRINTSTR

     ld hl, PUEDEDISPARAR
     ld (hl), 0

     ld a, 7
     call INICIA_EFECTO

     ret

ENTERRECORD_Delete:
     ld hl, PUEDEDISPARAR
     ld a, (hl)
     and a
     jp z, ENTERRECORD_Bucle


     ld hl, VAR2
     ld a, (hl)
     and a
     jp z, ENTERRECORD_Bucle

     dec (hl)
     ld e, (hl)
     ld d, 0
     ld hl, (VAR3)
     add hl, de
     ld (hl), ' '

     ld hl, (VAR3)
     ld bc, #140D
     call PRINTSTR

     ld hl, PUEDEDISPARAR
     ld (hl), 0

     jp ENTERRECORD_Bucle

; --------------------------------------------------------------------------------------------
include "intro.asm"
include "isr.asm"
; --------------------------------------------------------------------------------------------

END ILOGICALL
