UNPACK_MENU:

     ld e, PAPER_BLACK | INK_GREEN       ; Borramos la pantalla en azul y amarillo
     ld d, #ff
     ld (ATTR_ACT), de
     call CLS

     ld hl, MUS_MENU
     call START

     ld hl, GFX_MENU
     call DEPACK_SCR

     ret

MENU:
     call CALCULA_FLANES

     ld de, 0                            ; Ajustamos los subniveles: SIEMPRE vamos a empezar desde el subnivel 0
     ld (SUBNIVELES), de                 ; As que ajustamos las dos variables a 0
                                         ; Para que al iniciar el nivel, salte a iniciar nuevo nivel
                                         ; y no nuevo subnivel
     ld de, 0
     ld (SCORE), de

;     call UNPACK_MENU

     ld hl, 23264
     ld a, PAPER_BLACK | INK_MAGENTA | BRIGHT
     ld bc, 32
     call SETMEM

     xor a
     ld (CONT_SCR_MENU), a
     ld de, 0
     ld (CONT_SCR_MENU+1), de

     ld hl, STR_CREDITS
     ld a, (hl)
     call IMPR_NCHAR1

     ld hl, VAR3
     ld a, (hl)
     cp #ff
     call z, MENU_HOF

     call MENU_TXT

     ld hl, PUEDEDISPARAR
     ld (hl), 1

     MENUBUCLE:

     call MENUSCR

     ld hl, 23264 - 2 * 32 + 7
     ld bc, 18
     ld de, COLORCITOS
     call SCRCOLORCITOS


     call KFIND

     cp KEY_1
     call z, MENU_OP1
     cp KEY_2
     call nz, MENU_NOOP2
     call z, MENU_OP2
     cp KEY_3
     call z, MENU_OP3

     cp KEY_4
     jp z, EDMENU

     ld de, (VAR3)
     inc de
     ld (VAR3), de
     ld a, d
     cp 1
     call nc, MENU_HOF

     call JOYSTICK_TRIGGER

     ld a, (JOYSTICK)
     ld b, #10 ; Si seleccionamos Kempston sin tener el interface conectado, para que no se inicie solo el juego, esperamos la pulsacin del disparo UNICAMENTE
     cp b
     jp nz, MENUBUCLE

     ret


MENU_TXT:
     ld e, PAPER_BLACK | INK_GREEN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_MENU1
     ld bc, #0c08
     call PRINTSTRX2

     inc hl
     ld bc, #0e08
     call PRINTSTRX2

     inc hl
     ld bc, #1008
     call PRINTSTRX2

     inc hl
     ld bc, #1208
     call PRINTSTRX2

     ld hl, STR_MENU5
     ld bc, #1507
     call PRINTSTR

     call CONTROLTXT
     ld bc, #0e0B
     call PRINTSTRX2

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld de, 0
     ld bc, #0c16
     call PRINTNUMX2

     ld hl, LEVELACT                     ; Ponemos el puntero del nivel actual en el primer nivel
     ld e,(hl)
     ld bc, #0c17
     call PRINTNUMX2

     ret

CONTROLTXT:
     ld de, CONTROL
     ld hl, STR_CONTROL1
     ld a, (de)

     ld de, CONTROLS_KEYB
     ld (CONTROLPT), de

     and a
     ret z

     ld hl, STR_CONTROL2

     ld de, CONTROLS_SINC
     ld (CONTROLPT), de

     cp 1
     ret z

     ld hl, STR_CONTROL3

     ld de, CONTROLS_KEMP
     ld (CONTROLPT), de

     ret

MENU_CLSTXT:
     ld b, #0c

     MEN_CLS_BUC1:
     ld c, 7
     call DF_LOCATE

     push bc
     ld b, 8

     MEN_CLS_BUC2:

     push bc
     ld (hl),0
     ld d, h
     ld e, l
     inc de
     ld bc, 17
     ldir
     ld de, -17
     add hl, de
     inc h

     pop bc

     djnz MEN_CLS_BUC2

     pop bc
     inc b
     ld a, b
     cp #17
     jp nz, MEN_CLS_BUC1

     ret

MENU_HOF:
     call MENU_CLSTXT

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_HALLOFFAME
     ld bc, #0c0a
     call PRINTSTRX2

     ld hl, ATTR_ACT+1
     ld (hl), 0

     ld de, 0
     ld (VAR3), de

     BUCLE_HOF_Print:

     ld de, STR_RECORDS
     ld a, (VAR3)
     ld h, 0
     ld l, a
     add hl, hl
     add hl, hl
     add hl, hl
     add hl, de

     ld bc, #0f09
     add a, b
     ld b, a
     call PRINTSTR

     ld hl, STR_HISCORE
     inc c
     inc c
     call PRINTSTR

     dec c
     ld a, (VAR3)
     ld e, a
     ld d, 0
     ld hl, HISCORES
     add hl, de
     add hl, de
     ld e, (hl)
     inc hl
     ld d, (hl)
     call PRINTNUM

     ld hl, VAR3
     ld a, (hl)
     inc a
     ld (hl),a
     cp 5
     jp nz, BUCLE_HOF_Print

     xor a
     in a, (#FE)
     cpl
     and #1f
     ld b, a

     HOF_BUCLE:

     push bc

     ld hl, 23264 - 8 * 32 + 7
     ld de, COLORCITOS + 64
     ld bc, 16
     call SCRCOLORCITOS

     ld hl, 23264 - 7 * 32 + 7
     ld de, COLORCITOS + 64
     ld bc, 16
     call SCRCOLORCITOS

     ld hl, 23264 - 6 * 32 + 7
     ld de, COLORCITOS + 64
     ld bc, 16
     call SCRCOLORCITOS

     ld hl, 23264 - 5 * 32 + 7
     ld de, COLORCITOS + 64
     ld bc, 16
     call SCRCOLORCITOS

     ld hl, 23264 - 4 * 32 + 7
     ld de, COLORCITOS + 64
     ld bc, 16
     call SCRCOLORCITOS


     call MENUSCR

     pop bc

     xor a
     in a, (#FE)
     cpl
     and #1f
     xor b
     jr nz, HOF_SALIDA


     ld de, (VAR3)
     inc de
     ld (VAR3), de
     ld a, d
     cp 1
     jp c, HOF_BUCLE

     HOF_SALIDA:

     call MENU_CLSTXT

     call MENU_TXT

     ld de, 0
     ld (VAR3), de

     ret

MENU_OP3:
     ld a, 7
     call INICIA_EFECTO

     call RESET_PREVIOUSCONTROLS

     call MENU_CLSTXT

     ld e, INK_GREEN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #0c07
     ld hl, STR_REDEFINE
     call PRINTSTR


     ld e, INK_BLUE
     ld d, #ff
     ld (ATTR_ACT), de

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     ld c, #07
     call PRINTSTR

     inc hl
     inc b
     inc b
     ld c, #07
     call PRINTSTR

     ld e, INK_GREEN | BRIGHT
     ld d, #FF
     ld (ATTR_ACT), de

     ld hl, VAR2
     ld (hl),0

     ld b, 9

     OP3_BUCLEPpal:

     push bc

     call WFNK_SCR

     call OP3_LEETECLA

     ld hl, VAR2
     inc (hl)

     ld a, (hl)
     add a, #0c
     ld b, a
     ld c, 7
     call ATT_LOCATE
     ld d, h
     ld e, l
     inc de
     ld (hl), INK_GREEN | BRIGHT
     ld bc, 17
     ldir

     pop bc
     djnz OP3_BUCLEPpal

     ld bc, #1607
     call ATT_LOCATE
     ld d, h
     ld e, l
     inc de
     ld (hl), INK_CYAN | BRIGHT
     ld bc, 17
     ldir

     call WFNK_SCR

     OP3_CONFIRM:

     call MENUSCR


     call KFIND
     cp KEY_N
     jp z, MENU_OP3
     cp KEY_Y
     jp nz, OP3_CONFIRM



     call MENU_CLSTXT

     call MENU_TXT

     ret




WFNK_SCR:
     call MENUSCR
     call KFIND
     cp #ff
     jp nz, WFNK_SCR
     ret


OP3_LEETECLA:
     call MENUSCR

     call KFIND
     cp #27
     jp nc, OP3_LEETECLA

     call OP3_TECLAVALIDA
     jp c, OP3_LEETECLA



     ld hl, VAR2
     ld l, (hl)
     ld h, 0

     ld b, l

     ld de, CONTROLS
     add hl, de
     ld (hl), a

     ld c, #18

     ld hl, STR_KEYREAD
     ld e, a
     ld d, 0
     add hl, de

     ld a, b
     add a, #0c
     ld b, a

     ld a,(hl)

     call PRINTCHR

     ld a, 7
     call INICIA_EFECTO

     ret


; OP3_TECLAVALIDA
; Devuelve el carry activado si la tecla elegida ya se ha usado antes

OP3_TECLAVALIDA:
     ld b, 9
     ld hl, CONTROLS

     TECLAVALIDA_BUCLE:

     ld c, (hl)
     cp c
     scf
     ret z

     inc hl

     djnz TECLAVALIDA_BUCLE

     and a

     ret





RESET_PREVIOUSCONTROLS:
     ld hl, CONTROLS
     ld de, CONTROLS + 1
     ld bc, 8
     ld (hl), #ff
     ldir

     ret

MENU_OP2:
     ld hl, TRIGGERMENU
     ld a, (hl)
     and a
     ret nz

     ld a, 7
     call INICIA_EFECTO

     ld hl, CONTROL
     ld a, (hl)
     inc a

     ld (hl), a
     cp 3
     jp c, OP2_TXT

     ld (hl),0

     OP2_TXT:

     ld e, PAPER_BLACK | INK_GREEN
     ld d, #ff
     ld (ATTR_ACT), de
     call CONTROLTXT
     ld bc, #0e0B
     call PRINTSTRX2

     ld hl, TRIGGERMENU
     ld (hl), 1

     ret

MENU_NOOP2:
     ld hl, TRIGGERMENU
     ld (hl), 0
     ret

MENU_OP1:

     ld a, 7
     call INICIA_EFECTO

     ld e, PAPER_BLACK | INK_CYAN
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_MENU1
     ld bc, #0c08
     call PRINTSTRX2

     call MENU_OP1_SHOWNUM

     ld hl, STR_LINEAENBLANCO + 14
     ld bc, #1507
     call PRINTSTR

     ld hl, STR_SELECTLEVEL
     ld bc, #150a
     call PRINTSTR

     inc hl
     ld bc, #1607
     call PRINTSTR

     MENU_OP1_Bucle:

     call MENUSCR
     call JOYSTICK_TRIGGER

     ld a, (JOYSTICK)
     bit 0, a
     call nz, OP1_DER

     ld a, (JOYSTICK)
     bit 1, a
     call nz, OP1_IZQ

     ld a, (JOYSTICK)
     bit 4, a
     jp nz, MENU_OP1_EXIT

     jp MENU_OP1_Bucle

     MENU_OP1_EXIT:

     ld hl, STR_LINEAENBLANCO + 14
     ld bc, #1507
     call PRINTSTR

     ld hl, STR_LINEAENBLANCO + 14
     ld bc, #1607
     call PRINTSTR

;     ld a, #ff
;     ld (PUEDEDISPARAR), a

     call MENU_TXT
     ret

OP1_IZQ:
     ld hl, LEVELACT
     ld a, (hl)
     and a
     ret z

     dec (hl)

     jp MENU_OP1_SHOWNUM

OP1_DER:
     ld hl, LEVELACT
     ld a, (hl)
     cp 99
     ret z

     ld b, a
     ld a, (MAXLEVEL)
     and a
     jp z, MENU_OP1_ENTERPASS

     dec a
     cp b
     jp c, MENU_OP1_ENTERPASS

     inc (hl)

     jp MENU_OP1_SHOWNUM

MENU_OP1_SHOWNUM:

     ld e, PAPER_BLACK | INK_WHITE
     ld d, #ff
     ld (ATTR_ACT), de

     ld de, 0
     ld bc, #0c16
     call PRINTNUMX2

     ld hl, LEVELACT                     ; Ponemos el puntero del nivel actual en el primer nivel
     ld e,(hl)
     ld bc, #0c17
     call PRINTNUMX2

     ret

MENU_OP1_ENTERPASS:

     pop af ; Nos bajamos un registro de la pila, para que al volver con RET volvamos al bucle del men y no al de elegir nivel

     ld hl, STR_PWDTYPED
     ld (hl),' '
     ld de, STR_PWDTYPED + 1
     ld bc, 5
     ldir

     ld e, INK_CYAN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, STR_LINEAENBLANCO + 14
     ld bc, #1507
     call PRINTSTR

     ld hl, STR_LINEAENBLANCO + 14
     ld bc, #1607
     call PRINTSTR

     ld hl, STR_ENTERPWD
     ld bc, #1409
     call PRINTSTR

     ld e, INK_WHITE | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld hl, VAR2                          ; La vamos a usar como contador de caracteres de la contrasea introducida
     ld (hl), 0

     OP1_WFNK:

     call MENUSCR

     call KFIND
     cp #ff
     jp nz, OP1_WFNK


     OP1_Bucle:

     call MENUSCR

     call KFIND
     cp #ff
     jp z, OP1_NoKey

     cp 40
     jp z, OP1_Delete


     push hl
     ld hl, PUEDEDISPARAR
     ld a, (hl)
     and a
     pop hl
     jp z, OP1_Bucle

     call OP1_Key

     ld hl, VAR2
     ld a, (hl)
     cp 6
     jp nz, OP1_Bucle

     call CHECKPWD

     ld hl, STR_LINEAENBLANCO + 14
     ld bc, #1407
     call PRINTSTR

     ld hl, STR_LINEAENBLANCO + 14
     ld bc, #1507
     call PRINTSTR

     call MENU_TXT

     ret

OP1_NoKey:
     ld hl, PUEDEDISPARAR
     ld (hl), 1
     jp OP1_Bucle

OP1_Key:
     ld a, (hl)

     cp 'A'
     ret c

     cp 'Z'+1
     ret nc

     ld hl, VAR2
     ld e, (hl)
;     ld d, 0
     inc (hl)
     ld hl, STR_PWDTYPED
     add hl, de
     ld (hl), a


     ld hl, STR_PWDTYPED
     ld bc, #150d
     call PRINTSTR

     ld hl, PUEDEDISPARAR
     ld (hl), 0

     ld a, 7
     call INICIA_EFECTO

     ret

OP1_Delete:
     ld hl, PUEDEDISPARAR
     ld a, (hl)
     and a
     jp z, OP1_Bucle


     ld hl, VAR2
     ld a, (hl)
     and a
     jp z, OP1_Bucle

     dec (hl)
     ld e, (hl)
     ld d, 0
     ld hl, STR_PWDTYPED
     add hl, de
     ld (hl), ' '

     ld hl, STR_PWDTYPED
     ld bc, #150d
     call PRINTSTR

     ld hl, PUEDEDISPARAR
     ld (hl), 0

     jp OP1_Bucle


MENUSCR:
     push hl
     push af
     push de
     push bc

     halt

     ld hl, CONT_SCR_MENU
     inc (hl)
     ld a, (hl)
     cp 8
     call z, IMPR_NCHAR0

     call DIBUJA_FLAN

     call MYSCR

     pop bc
     pop de
     pop af
     pop hl

     ret

MYSCR:
    ld hl, 0x57ff                         ; Empezamos en la ltima lnea
    ld de, BUFCREDITS + 7                 ; Bfer donde est "impreso" el carcter que est fuera
    ld c, 8                               ; 8 pxeles de alto
    MYSCR_buc_2:
    ld b,32                               ; 32 bytes de ancho
    ex de, hl                             ; Vamos a rotar el "bfer", para "cargar" el acarreo
    rl (hl)                               ; Y no se puede rotar el contenido de DE... as que...
    dec hl                                ; Pasamos a la lnea superior de ese "bfer"
    ex de, hl                             ; Y cada registro a su sitio
    MYSCR_buc_1:
    rl (hl)                               ; Rotamos el byte que corresponda
    dec hl                                ; Y pasamos al siguiente
    djnz MYSCR_buc_1
    dec h                                 ; Para no pasarnos de caracter, tenemos que restar (255 - 32)
    ld a,l                                ; Y ahora sumamos el 32 que no restamos antes
    add a,32                              ; Pues eso
    ld l,a                                ; Y lo devolvemos a L
    dec c
    jr nz, MYSCR_buc_2
    ret

IMPR_NCHAR0:
     ld hl, CONT_SCR_MENU
     ld (hl), 0

     ld de, (CONT_SCR_MENU+1)
     inc de
     ld (CONT_SCR_MENU+1), de

     IMPR_NCHAR0_Hook:

     ld hl, STR_CREDITS
     add hl, de
     ld a, (hl)

     and a
     jp nz, IMPR_NCHAR1

     ld de, 0
     ld (CONT_SCR_MENU+1), de

     jp IMPR_NCHAR0_Hook

IMPR_NCHAR1:
      ld h, 0
      ld l, a
      add hl, hl
      add hl, hl
      add hl, hl
      ld de, CHARSET
      dec d
      add hl, de
      ex de, hl

      ld hl, BUFCREDITS
      ld b, 8

      IMPRNC_Bucle:
      ld a, (de)
      ld (hl), a
      inc hl
      inc de
      djnz IMPRNC_Bucle

      ret


CHECKPWD:
     di
     ld a, (SETTYPE)                               ; Cogemos el nivel del banco que sea, en funcin de si es el juego "original" o el "customizado"
     ld b, a

     call SETRAMBANK


     ld ix, STR_PWDTYPED

     ld a, (ix + 2)
     sub 'A'
     ld e, a
     sla e
     sla e
     sla e
     sla e

     ld a, (ix + 3)
     sub 'A'
     or e

     ld e,a
     ld d,0
     
     push de


     ld a, (ix + 0)
     sub 'A'
     ld c, a
     sla c
     sla c
     sla c
     sla c

     ld a, (ix + 1)
     sub 'A'
     or c

     ld c,a

     ld hl, LEVELDATA                              ; Ahora apuntamos a la lista de punteros de niveles
     add hl, de                                    ; Le aadimos el nmero de nivel dos veces
     add hl, de                                    ; porque son dos bytes por puntero
     ld e, (hl)
     inc hl
     ld d, (hl)                                    ; Ahora DE nos apunta al inicio del nivel que sea
     inc de                                        ; Para saltarnos el nmero de subniveles
     ex de, hl                                     ; Nos lo pasamos a HL
     
     pop de                                        ; Para volver a tener el nmero de nivel en DE

     ld a, (hl)
     cp c

     jp nz, CHECKPWD_NoVale

     inc hl

     ld a, (ix + 4)
     sub 'A'
     ld c, a
     sla c
     sla c
     sla c
     sla c

     ld a, (ix + 5)
     sub 'A'
     or c

     ld c,a

     ld a, (hl)
     cp c

     jp nz, CHECKPWD_NoVale

     call ED_DESACTIVABANK


     ld a, e
     ld hl, LEVELACT

     ld (hl), a                     ; Ponemos el puntero del nivel actual en el primer nivel
     inc hl
     cp (hl)
     jp c, CHKCKPD_NoSupera

     ld (hl), a

     CHKCKPD_NoSupera:

     ld hl, 0
     ld (SUBNIVELES), hl

     call MENU_TXT

     ret

CHECKPWD_NoVale:
     call ED_DESACTIVABANK

     ld e, INK_CYAN | BRIGHT
     ld d, #ff
     ld (ATTR_ACT), de

     ld bc, #1407
     ld hl, STR_PWDNOVALE
     call PRINTSTR

     call WAITFORNOKEY

     call RESETCLOCK

     CHKPWDNoVale_Bucle:

     call MENUSCR

     xor a              ; Si pulsas alguna tecla
     in a, (#FE)
     cpl
     and #1f
     ret nz             ; Vulvete ya

     ld hl, SEGUNDOS
     ld a, (hl)
     cp 3
     jp nz, CHKPWDNoVale_Bucle ; Si no llevas 3 segundos, sigue en el bucle

     ret

CALCULA_FLANES:

     ld d, 6
     ld bc, #0607
     ld ix, FLAN_Coord

     CALCF_Bucle:

     call DF_LOCATE
     ld (ix + 0), l
     ld (ix + 1), h
     inc ix
     inc ix

     inc b
     dec d
     ret z
     jp CALCF_Bucle

PREPARA_COORDF:
     push de
     push bc

     ld e, c
     ld d, 0
     ld hl, FLAN_Coord
     add hl, de
     add hl, de

     ld c, (hl)
     inc hl
     ld b, (hl)

     push bc
     pop hl

     pop bc
     pop de
     ret

AJUSTA_FLAN:
     ld hl, FLAN_Act
     inc (hl)
     ld a, (hl)
     cp 4
     jp nz, AF_Continua
     
     ld (hl),0

     AF_Continua:

     ld e, (hl)
     ld d, 0
     ld hl, FLAN_Anim
     add hl, de
     add hl, de

     ld e, (hl)
     inc hl
     ld d, (hl)
     ret



DIBUJA_FLAN:
      ld hl, FLAN_Ret
      dec (hl)
      ret nz

      ld (hl), 4

      call AJUSTA_FLAN

      ld b, 6
      ld c, 0


      DF_B0:

      call PREPARA_COORDF

      push bc

      ld c, 8

      DF_B1:

      ld b, 6

      DF_B2:
      ld a, (de)
      ld (hl), a
      inc hl
      inc de
      djnz DF_B2

      ld a, l
      sub 6
      ld l, a
      inc h

      dec c
      jp nz, DF_B1

      pop bc
      inc c

      djnz DF_B0
      
      ret