BLACK              EQU    0
BLUE               EQU    1
RED                EQU    2
MAGENTA            EQU    3
GREEN              EQU    4
CYAN               EQU    5
YELLOW             EQU    6
WHITE              EQU    7

INK_BLACK          EQU    0
INK_BLUE           EQU    1
INK_RED            EQU    2
INK_MAGENTA        EQU    3
INK_GREEN          EQU    4
INK_CYAN           EQU    5
INK_YELLOW         EQU    6
INK_WHITE          EQU    7

PAPER_BLACK        EQU    0
PAPER_BLUE         EQU    8
PAPER_RED          EQU  #10
PAPER_MAGENTA      EQU  #18
PAPER_GREEN        EQU  #20
PAPER_CYAN         EQU  #28
PAPER_YELLOW       EQU  #30
PAPER_WHITE        EQU  #38

BRIGHT             EQU  #40
FLASH              EQU  #80

; DRAWGFX: Dibuja un grfico en pantalla (Tiene que estar por lneas y en zigzag)
; ENTRADA: HL puntero al grfico, BC Coordenadas en caracteres, DE: D = Caract Ancho E = Caract. Alto

DRAWGFX:
     ld (DRGVAR1), bc
     ld (DRGVAR2), bc
     ld (DRGVAR3), de
     ld (DRGVAR4), hl

     push de
     
     push hl

     DRAWGFX_B0:

     call DF_LOCATE
     ex de, hl
     pop hl
;     ld hl, (DRGVAR4)               ; Ahora tenemos en HL el origen y en DE el destino

     ld a, (DRGVAR3 + 1)
     ld b, a
     ld c, 4

     DRAWGFX_B1:

     ld a, (hl)
     ld (de), a
     inc hl
     inc de
     djnz DRAWGFX_B1

     ld a, (DRGVAR3 + 1)
     ld b, a
     dec de
     inc d

     DRAWGFX_B2:

     ld a, (hl)
     ld (de), a
     inc hl
     dec de
     djnz DRAWGFX_B2

     ld a, (DRGVAR3 + 1)
     ld b, a
     inc de
     inc d

     dec c
     jp nz, DRAWGFX_B1


     ld bc, (DRGVAR1)
     inc b
     ld (DRGVAR1), bc


     pop bc               ; Y en BC las dimensiones
     dec c
     push bc
     push hl
     ld bc, (DRGVAR1)
     jp nz, DRAWGFX_B0

     ld bc, (DRGVAR2)


     pop hl

     pop af                 ; Le debemos una a la pila :P


     DRAWGFX_B3:

     push bc

     push hl
     call ATT_LOCATE
     ex de, hl
     pop hl                 ; Igual que antes: HL = Origen, DE = Destino


     ld bc, (DRGVAR3)          ; Ahora tenemos en BC las dimensiones


     DRAWGFX_B4:

     ld a, (hl)
     ld (de), a
     inc hl
     inc de

     djnz DRAWGFX_B4

     dec c
     jp z, DRAWGFX_Exit

     ld a, c
     ld (DRGVAR3), a

     pop bc
     inc b
     ld a, (DRGVAR2)
     ld c, a
     jp DRAWGFX_B3

DRAWGFX_Exit:
     pop af
     ret

; PRINTSTR: Imprime la cadena apuntada por HL a partir de las coordenadas BC
; ENTRADA:
; BC: B = Fila C = Columna
; HL: Direccin donde empieza el texto a imprimir
; Utiliza A
; SALIDA:
; BC = Coordenadas del ltimo carcter
; HL = Direccin siguiente al ltimo carcter (0)
; NO conserva HL

PRINTSTR:
      ld a, (hl)
      and a
      ret z

      push hl
      call PRINTCHR
      pop hl

      inc hl
      inc bc
      ld a, c
      cp 32
      jr c, PRINTSTR
      ld c,0
      inc b
      jp PRINTSTR

      ret

; PRINTSTRX2: Imprime la cadena apuntada por HL a partir de las coordenadas BC
; ENTRADA:
; BC: B = Fila C = Columna
; HL: Direccin donde empieza el texto a imprimir
; Utiliza A
; SALIDA:
; BC = Coordenadas del ltimo carcter
; HL = Direccin del ltimo carcter (0)
; NO conserva HL

PRINTSTRX2:
      ld a, (hl)
      and a
      ret z

      push hl
      call PRINTCHRX2
      pop hl

      inc hl
      inc bc
      ld a, c
      cp 32
      jr c, PRINTSTRX2
      ld c,0
      inc b
      jp PRINTSTRX2

      ret

; PRINTSTR6x8: Imprime la cadena usando el set de anchura variable (en ppio. eran 6 x 8 de ah el nombre :P )
; ENTRADA:
; BC: B = Fila C = halts de retardo entre letra y letra
; HL: Direccin donde empieza el texto a imprimir
; A: Pxel X donde empezar a imprimir
; Utiliza (VAR3) y todos los registros

PRINTSTR_6X8:
      ld (VAR3), a

PRINTSTR_6X8_B:
      ld a, (hl)
      and a
      ret z

      push bc
      push hl
      call PRINTCHR_6X8
      pop hl
      pop bc

      ld a, b
      ld b, c
      push af
      push bc
      call PAUSE
      pop bc
      pop af
      ld b, a

      ld a, (hl)
      inc hl
      
      push hl
      
      sub 32
      ld e, a
      ld d, 0

      ld hl, INCSET68
      add hl, de
      ld d, (hl)

      ld a, (VAR3)
      add a, d

      ld (VAR3), a

      pop hl
      jp PRINTSTR_6X8_B



; PRINTCHR: Imprime el carcter cuyo cdigo est en A en las coordenadas BC
; Entrada: A = Caracter a imprimir
; Salida: DE = Direccin donde est el carcter

PRINTCHR:
      ld h, 0
      ld l, a
      add hl, hl
      add hl, hl
      add hl, hl
      ld de, CHARSET
      dec d
      add hl, de
      ex de, hl

      call PRINT
      ret

PRINTCHR_6X8:
      push hl
      ld h, 0
      ld l, a
      add hl, hl
      add hl, hl
      add hl, hl
      ld de, SET6X8
      dec d
      add hl, de
      ex de, hl
      pop hl

      call PRINT_6X8
      ret


; PRINTCHRX2: Imprime el carcter cuyo cdigo est en A en las coordenadas BC en doble altura
; Entrada: A = Caracter a imprimir
; Salida: DE = Direccin donde est el carcter

PRINTCHRX2:
      ld h, 0
      ld l, a
      add hl, hl
      add hl, hl
      add hl, hl
      ld de, CHARSET
      dec d
      add hl, de
      ex de, hl

      call PRINTX2
      ret

; PRINTNUM: Imprime el nmero dado por DE en las coordenadas BC
; Utiliza A
PRINTNUM:
      ld (VAR1), de
      ld a, 10
      ld (VAR2), a

      push bc
      call DIVI
      pop bc

      add a, '0'

      call PRINTCHR

      dec c

      ld de, (VAR1)

      ld a, d
      or e
      jp nz, PRINTNUM

      ret

; PRINTNUM: Imprime el nmero dado por DE en las coordenadas BC
; Utiliza A e IX
PRINTNUMX2:

      ld (VAR1), de
      ld a, 10
      ld (VAR2), a

      push bc
      call DIVI
      pop bc

      add a, '0'

      call PRINTCHRX2

      dec c
      
      ld de, (VAR1)

      ld a, d
      or e
      jp nz, PRINTNUMX2

      ret

; PRINT: Imprime el carcter apuntado por DE en las coordenadas BC
; BC: B = Linea, C = Columna
; DE = Direccin carcter
; Como llama a LOCATE y ATT_LOCATE, destruye el contenido de HL
; Salida: DE = Apuntando al primer byte DESPUS del carcter actual

PRINT:
      call DF_LOCATE
      ld a, 8
      PRINT_Bucle:
      ex af, af'
      ld a, (de)
      ld (hl), a
      inc de
      inc h
      ex af, af'
      dec a
      jr nz, PRINT_Bucle


      call ATT_LOCATE

      push ix
      ld ix, ATTR_ACT

      ld a, (ix)
      and (ix+1)
      ld (ix), a

      ld a, (ix + 1)
      cpl
      and (hl)
      or (ix)
      ld (hl), a

      pop ix

      ret


; PRINT: Imprime el carcter apuntado por DE en las coordenadas BC
; BC: B = Linea, C = Columna
; DE = Direccin carcter
; Como llama a LOCATE y ATT_LOCATE, destruye el contenido de HL
; Salida: DE = Apuntando al primer byte DESPUS del carcter actual

PRINT_6X8:
      ld a, (VAR3)
      srl a
      srl a
      srl a
      ld c,a
      call DF_LOCATE
      ex de, hl


      ld a, 8

      PRINT6X8_Bucle:
      ex af, af'

      ld c,(hl)
      ld b, 0

      ld a, (VAR3)
      and 7
      call nz, P68_Rot

      ex de, hl

      ld a, (hl)
      or c
      ld (hl), a
      inc hl

      ld a, (hl)
      or b
      ld (hl), a
      dec hl

      ex de, hl



      inc d
      inc hl

      ex af, af'
      dec a
      jr nz, PRINT6X8_Bucle

      ret

P68_Rot:
;      and a

      srl c
      rr b

      dec a

      ret z
      jp P68_Rot




; PRINTX2: Imprime el carcter apuntado por DE en las coordenadas BC en doble altura
; BC: B = Linea, C = Columna
; DE = Direccin carcter
; Como llama a LOCATE y ATT_LOCATE, destruye el contenido de HL
; Salida: DE = Apuntando al primer byte DESPUS del carcter actual

PRINTX2:
      call DF_LOCATE
      ld a, 4
      PRINTX2_Bucle1:
      ex af, af'
      ld a, (de)
      ld (hl), a
      inc h
      ld (hl), a
      inc h
      inc de
      ex af, af'
      dec a
      jr nz, PRINTX2_Bucle1


      call ATT_LOCATE

      push ix

      ld ix, ATTR_ACT

      ld a, (ix)
      and (ix+1)
      or BRIGHT
      ld (ix), a

      ld a, (ix + 1)
      cpl
      and (hl)
      or (ix)
      ld (hl), a



      inc b

      call DF_LOCATE
      ld a, 4
      PRINTX2_Bucle2:
      ex af, af'
      ld a, (de)
      ld (hl), a
      inc h
      ld (hl), a
      inc h
      inc de
      ex af, af'
      dec a
      jr nz, PRINTX2_Bucle2



      call ATT_LOCATE

      ld ix, ATTR_ACT

      ld a, (ix)
      and (ix+1)
      xor BRIGHT
      ld (ix), a

      ld a, (ix + 1)
      cpl
      and (hl)
      or (ix)
      ld (hl), a

      pop ix

      dec b

      ret


; ATT_LOCATE: De vuelve en HL la direccin de atributos
; Entrada: BC Coordenadas: B = Lnea C = Columna
; Salida: HL Direccin de atributos
; Se conservan DE y BC

ATT_LOCATE:
    ld a, b
    sra a
    sra a
    sra a
    add a, #58
    ld h, a
    ld a, b
    and 7
    rrca
    rrca
    rrca
    add a, c
    ld l, a
    ret


; DF_LOCATE: De vuelve en HL la direccin del archivo de pantalla
; Entrada: BC Coordenadas: B = Lnea C = Columna
; Salida: HL Direccin del archivo de pantalla
; Se conservan DE y BC

DF_LOCATE:
    ld a, b
    and #f8
    add a, #40
    ld h, a
    ld a, b
    and 7
    rrca
    rrca
    rrca
    add a, c
    ld l, a
    ret



; CLS: Borra la pantalla
; Utiliza los registros hl, bc, y de
CLS:
    ld hl, ATTR_ACT
    ld a, (hl)

    ld hl, $4000
    ld (hl), l
    ld bc, $1800
    ld d, h
    ld e, 1
    ldir
    ld (hl), a
    ld bc, $300
    ldir

    and #38
    srl a
    srl a
    srl a

    out (#fe),a


    ret

CORTINILLA:
    ld e, 8
    CBucle:
    ld hl, $4000
    ld c, 96
    CBucle0:
    ld b, 16
    CBucle1:
    and a
    rl (hl)
    inc hl
    and a
    rr (hl)
    inc hl
    djnz CBucle1

    ld b,16
    CBucle2:
    and a
    rl (hl)
    inc hl
    and a
    rr (hl)
    inc hl
    djnz CBucle2

    dec c
    jp nz, CBucle0
    dec e
    jp nz, CBucle
    ret

ESPIRAL:
    ld ix, VAR1
    ld (ix+0), 23
    ld (ix+1), 32

    ld hl, 22527
    ld de, 32

    bb0:

    ld b, (ix+1)

    ld a, (ix)
    and a
    ret z
    ld a, (ix+1)
    and a
    ret z

    halt

    bb1:

    ld (hl), 0
    inc hl
    djnz bb1

    ld a, (ix+1)
    dec a
    ld (ix+1), a


    ld b, (ix+0)

    bb2:

    ld (hl), 0
    add hl, de
    djnz bb2

    ld a, (ix+0)
    dec a
    ld (ix+0), a


    ld b, (ix+1)

    bb3:

    ld (hl), 0
    dec hl
    djnz bb3

    ld a, (ix+1)
    dec a
    ld (ix+1), a

    ld b, (ix+0)

    bb4:

    ld (hl), 0
    sbc hl, de
    djnz bb4

    ld a, (ix+0)
    dec a
    ld (ix+0), a

    jp bb0


; HL = Direccin donde empieza la fila de atributos a pintar
; DE = Direccin donde empiezan los datos de los atributos a poner
; BC = Columnas a hacer el scrollColorcitos

SCRCOLORCITOS:

     push bc

     push de
     ex de, hl
;     ld bc, 18
     ldir
     pop de

     ld a, (de)

     push de
     pop hl
     inc hl
     
     pop bc
     dec bc
;     ld bc, 17
     ldir

     ld (de), a

     ret


FADE_OUT:
;// El segundo programa de ms de 5 lineas en Z80 ASM de na_th_an
;/* Optimizado por Metalbrain */
  ld b, 7

  FADE_BUCLE0:

;/* Esto "oscurece" un paso la pantalla. Llamado 8 veces la dejar en negro */

  push bc

  ld  e, 3            ; 3 tercios
  ld  hl, 22528       ; aqu empiezan los atributos
  halt                ; esperamos retrazo.
fade_out_bucle
  ld  a, (hl)         ; nos traemos el atributo actual

  ld  d, a            ; tomar atributo
  and  7              ; aislar la tinta
  jr  z, ink_done     ; si vale 0, no se decrementa
  dec  a              ; decrementamos tinta
ink_done
  ld  b, a            ; en b tenemos ahora la tinta ya procesada.

  ld  a, d            ; tomar atributo
  and  56             ; aislar el papel, sin modificar su posicin en el byte
  jr  z, paper_done   ; si vale 0, no se decrementa
  sub 8               ; decrementamos papel restando 8
paper_done
  ld  c, a            ; en c tenemos ahora el papel ya procesado.
  ld  a, d
  and  192            ; nos quedamos con bits 6 y 7 (BRIGHT y FLASH)
  or  c               ; aadimos paper
  or  b               ; e ink, con lo que recompuesto el atributo
  ld  (hl),a          ; lo escribimos,
  inc  l              ; e incrementamos el puntero.
  jr  nz, fade_out_bucle ; continuamos hasta acabar el tercio (cuando L valga 0)
  inc  h              ; siguiente tercio
  dec  e
  jr  nz, fade_out_bucle ; repetir las 3 veces

  pop bc

  djnz FADE_BUCLE0

  ret

TRAMADO_PAUSA:
     ld hl, 22528
     ld de, 22529
     ld bc, 767
     ld (hl), 1
     ldir


     ld hl, 16383

     ld b, 3

     TRAMADO_PAUSA_B0:

     push bc


     ld b, 0
     ld c, 8
     ld d, $55

     TRAMADO_PAUSA_B1:

     inc hl

     ld a, (hl)
     and d
     ld (hl), a
     djnz TRAMADO_PAUSA_B1

     ld a, d
     cpl
     ld d, a
     dec c
     jp nz, TRAMADO_PAUSA_B1

     pop bc
     djnz TRAMADO_PAUSA_B0

     ret
     
SAVE_SCR:

     di
     ld b, 7
     call SETRAMBANK

     ld hl, $4000
     ld de, $e4fe
     ld bc, 6912
     ldir

     ld b, 0
     call SETRAMBANK
     ei

     ret

LOAD_SCR:

     di
     ld b, 7
     call SETRAMBANK

     ld hl, $e4fe
     ld de, $4000
     ld bc, 6912
     ldir

     ld b, 0
     call SETRAMBANK
     ei

     ret


INTERLEVEL_SCROLL:

     ld bc, $0d00
     call DF_LOCATE
     call LSCR_CHR

     ld bc, $0c00
     call DF_LOCATE
     call LSCR_CHR

     ld bc, $141f
     call DF_LOCATE
     call RSCR_CHR

     ld bc, $151f
     call DF_LOCATE
     call RSCR_CHR

     ret


LSCR_CHR:

     ld c, 8

     LSCR_CHR_1:

     ld b, 31

     ld a, (hl)

     srl a
     srl a
     srl a
     srl a

     ld (VARa3), a

     LSCR_CHR_2:

     ld a, (hl)

     sla a
     sla a
     sla a
     sla a

     inc hl
     ld e, (hl)
     srl e
     srl e
     srl e
     srl e

     dec hl
     or e
     ld (hl), a

     inc hl

     djnz LSCR_CHR_2

     ld e, (hl)

     sla e
     sla e
     sla e
     sla e

     ld a, (VARa3)
     or e
     ld (hl), a
     inc hl

     ld de, -32
     add hl, de
     inc h
     dec c

     jp nz, LSCR_CHR_1

     ret

RSCR_CHR:

     inc h
     inc h
     inc h
     inc h
     inc h
     inc h
     inc h

     ld c, 8

     RSCR_CHR_1:

     ld b, 31

     ld a, (hl)

     sla a
     sla a
     sla a
     sla a

     ld (VARa3), a

     RSCR_CHR_2:
     
     ld a, (hl)

     srl a
     srl a
     srl a
     srl a

     dec hl
     ld e, (hl)
     sla e
     sla e
     sla e
     sla e
     inc hl

     or e
     ld (hl), a

     dec hl

     djnz RSCR_CHR_2
     
     ld e, (hl)

     srl e
     srl e
     srl e
     srl e

     ld a, (VARa3)
     or e
     ld (hl), a
     dec hl

     ld de, 32
     add hl, de
     dec h
     dec c

     jp nz, RSCR_CHR_1

     ret


